package gr.ihu.cs.lmous.OOJ.k11.v1;

public class Rect {

    private double len, wid;
    public final static double c=0.00001;
    
    public static boolean approxEquals(double d1, double d2) {
        return Math.abs(d1-d2) < c;
    }

    public Rect(double len, double wid) {
        if (len < 0 || wid < 0) {
            throw new RuntimeException();
        }
        this.len = len;
        this.wid = wid;
    }

    public Rect(double len) {
        if (len < 0) {
            throw new RuntimeException();
        }
        this.len = len;
        this.wid = len;
    }

    public double getLen() {
        return len;
    }

    public double getWid() {
        return wid;
    }

    public void setLen(double len) {
        if (len < 0) {
            throw new RuntimeException();
        }
        this.len = len;
    }

    public void setWid(double wid) {
        if (wid < 0) {
            throw new RuntimeException();
        }
        this.wid = wid;
    }

    public double getArea() {
        return len * wid;
    }

    public double getPerimeter() {
        return 2 * (len + wid);
    }

    @Override
    public String toString() {
        return "Rect: len= " + len + " wid=" + wid;
    }

    @Override
    public boolean equals(Object obj) {
        if (this==obj) 
            return true;
        if (obj==null)
            return false;
        if (!(obj instanceof Rect))
            return false;
        Rect r=(Rect)obj;
        return approxEquals(len, r.len) && approxEquals(wid, r.wid);
    }

    public static void main(String[] args) {

        Rect r1 = new Rect(2, 5);
        Rect r2 = new Rect(2, 5);
        Rect sq = new Rect(4);
        Rect r3=r1;

        System.out.println(r1.getArea());
        System.out.println(r1.getPerimeter());
        System.out.println(r1);
        System.out.println(r1 == r2);
        System.out.println(r1.equals(r3));
    }
}
