
package gr.ihu.cs.lmous.OOJ.k11.v1.x;
// a+bi, (a,b)
public class Complex { //Κώδικας 11.15

    public static int format = 1;
    private double r;
    private double f;

    public Complex(double r, double f) {
        this.r = r;
        this.f = f;
    }

    public Complex(Complex c) {
        this(c.r, c.f);
    }

    public double getR() {
        return r;
    }

    public void setR(double r) {
        this.r = r;
    }

    public double getF() {
        return f;
    }

    public void setF(double f) {
        this.f = f;
    }

    @Override
    public int hashCode() {
        return Double.hashCode(r) + Double.hashCode(f);
    }

//    @Override
//    public int hashCode() {
//        int hash = 7;
//        hash = 89 * hash + (int) (Double.doubleToLongBits(this.r) ^ (Double.doubleToLongBits(this.r) >>> 32));
//        hash = 89 * hash + (int) (Double.doubleToLongBits(this.f) ^ (Double.doubleToLongBits(this.f) >>> 32));
//        return hash;
//    }

    
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Complex other = (Complex) obj;
        if (Double.compare(this.r, other.r) != 0) {
            return false;
        }
        return Double.compare(this.f, other.f) == 0;
    }

    @Override
    public String toString() {
        if (r==0 && f==0) return "0";
        String rVal="";
        if (format == 1) {
            if (r!=0)
                rVal+=r;  //8i, 2-81
            if (f>0)
                rVal+=(r!=0?"+":"")+f+"i";
            else
                if (f<0)
                    rVal+=f+"i";
        }
        else {
            rVal="("+r+","+f+")";
        }
        return rVal;
    }
    
    public Complex add(Complex c) {
        double real=r+c.r;
        double imagin=f+c.f;
        return new Complex(real, imagin);
    }
    
    public Complex subtract(Complex c) {
        double real=r-c.r;
        double imagin=f-c.f;
        return new Complex(real, imagin);
    }
    
    public Complex multiply(Complex c) {
        double real=r*c.r-f*c.f;
        double imagin=r*c.f+f*c.r;
        return new Complex(real, imagin);
    }
    
    public Complex divide(Complex c) {
        if (c.r==0 && c.f==0) 
            throw new RuntimeException();
        double real=c.r/(Math.pow(c.r, 2)+Math.pow(c.f, 2));
        double imagin=c.f/(Math.pow(c.r, 2)+Math.pow(c.f, 2));
        Complex divisor= new Complex(real,-imagin);
        return multiply(divisor);
    }
    
    public static void main(String[] args) {
        Complex.format=2;
        Complex c1=new Complex(2,3);
        Complex c2=new Complex(4,0);
        System.out.println(c1.divide(c2));
        c1=new Complex(20,-4);
        c2=new Complex(3,2);
        System.out.println(c1.divide(c2));
        //System.out.println(Double.doubleToLongBits(c1.r) ^ Double.doubleToLongBits(c1.r)>>> 32);
    }
}
