package gr.ihu.cs.lmous.OOJ.k11.v1.x;

import java.util.Random;

/**
 *
 * @author Lefteris Moussiades
 */
public class Deck { //Κώδικας 11.21

    private final Card[] deck;
    private int cardsInDeck;

    public Deck() { //Κώδικας 11.21 
        deck = new Card[52];
        cardsInDeck = 0;
        for (CardRank r : CardRank.values()) {
            for (Suit s : Suit.values()) {
                deck[cardsInDeck++] = new Card(r, s);
            }
        }
    }

    public void shuffle() {
        Random r = new Random();

        for (int i = 0; i < deck.length; i++) {
            int rIdx = r.nextInt(deck.length);
            Card tmp = deck[i];
            deck[i] = deck[rIdx];
            deck[rIdx] = tmp;
        }
    }

    public boolean empty() {
        return cardsInDeck == 0;
    }

    public Card pickCard() {
        cardsInDeck--;
        return deck[52 - cardsInDeck - 1];
    }

    @Override
    public String toString() {
        if (cardsInDeck == 0) {
            return "Empty Deck";
        }
        String rVal = "";
        for (int i = 52 - cardsInDeck; i < 52; i++) {
            if (i > 52 - cardsInDeck && i % 4 == 0) {
                rVal += "\n";
            }
            rVal += deck[i] + " ";
        }
        return rVal;
    }

    public static void main(String[] args) {
        Deck d1 = new Deck();
        Deck d2 = new Deck();
        
        for (int i = 0; i < 24; i++) {
            d1.pickCard();
        }
        System.out.println(d1.cardsInDeck);
        System.out.println(d1);
        System.out.println("");

        d2.shuffle();
        System.out.println(d2);
    }
}
