/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v1.x;

import java.util.HashMap;

public class DiceGame { //Κώδικας 11.18

    private final int noOfPlayers;
    private final int noOfRoll;

    private final DicePlayer john = new DicePlayer("John");
    private final DicePlayer jim = new DicePlayer("Jim", new double[]{1d / 6, 1d / 6, 1d / 6, 1d / 6, 0, 2d / 6});
    private final DicePlayer jack = new DicePlayer("Jack", new double[]{1d / 6, 1d / 6, 1d / 6, 1d / 6, 2d / 6, 0});

    private final HashMap<DicePlayer, Integer> scores = new HashMap<>();

    public DiceGame(int noOfPlayers, int noOfRoll) {
        this.noOfPlayers = noOfPlayers;
        this.noOfRoll = noOfRoll;
    }

    private void updScores(DicePlayer player) {
        Integer score = scores.get(player);
        if (score == null) {
            score = 0;
        }
        scores.put(player, score + 1);
    }

    private void aLot() {

        for (int i = 0; i < noOfRoll; i++) {
            int rslt = john.roll();
            if (rslt % 2 == 0) {
                updScores(john);
            }

            rslt = jim.roll();
            if (rslt % 2 == 0) {
                updScores(jim);
            }

            rslt = jack.roll();
            if (rslt % 2 == 0) {
                updScores(jack);
            }
        }
    }

    private boolean withdraw() {
        int score1 = scores.get(john),
                score2 = scores.get(jim),
                score3 = scores.get(jack);
        return (score1 == score2 || score2 == score3 || score1 == score3);
    }

    private DicePlayer max() {
        int scoreJohn = scores.get(john) != null ? scores.get(john) : 0;
        int scoreJim = scores.get(jim) != null ? scores.get(jim) : 0;
        int scoreJack = scores.get(jack) != null ? scores.get(jack) : 0;
        int max = scoreJohn;
        DicePlayer rVal = john;
        if (scoreJim > max) {
            max = scoreJim;
            rVal = jim;
        }
        if (scoreJack > max) {
            rVal = jack;
        }
        return rVal;
    }

    public DicePlayer play() {
        do {
            aLot();
        } while (withdraw());
        return max();
    }

    public int getNoOfPlayers() {
        return noOfPlayers;
    }

    public int getNoOfRoll() {
        return noOfRoll;
    }

    public static void main(String[] args) {
        DiceGame diceGame = new DiceGame(3, 10);
        DicePlayer winner = diceGame.play();
        System.out.println("Winner is " + winner.getName() + " Total Score " + diceGame.scores.get(winner));
    }
}
