package gr.ihu.cs.lmous.OOJ.k11.v1.x;

import java.util.Arrays;
import java.util.Objects;

/**
 *
 * @author Lefteris
 */
public class DicePlayer {//Κώδικας 11.17

    private final double[] distribution;
    private final String name;

    public DicePlayer(String name, double[] distribution) {

        if (distribution.length != 6
                || !Lib.approximateEquals(Lib.sum(distribution), 1)) {
            throw new RuntimeException();
        }
        this.name = name;
        this.distribution = distribution;
    }

    public DicePlayer(String name) {
        this(name, new double[]{1d / 6, 1d / 6, 1d / 6, 1d / 6, 1d / 6, 1d / 6,});
    }

    public int roll() {
        double value = Lib.gen.nextDouble();
        double sum = 0;

        for (int i = 0; i < distribution.length; i++) {
            sum += distribution[i];
            if (value <= sum) {
                return i + 1;
            }
        }
        return 0;
    }

    public String getName() {
        return name;
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(this.distribution)+this.name.hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DicePlayer other = (DicePlayer) obj;
        if (!Objects.equals(this.name, other.name)) {
            return false;
        }
        return Arrays.equals(this.distribution, other.distribution);
    }
}
