package gr.ihu.cs.lmous.OOJ.k11.v1.x;

import java.util.Objects;

/**
 *
 * author Lefteris Moussiades
 */
public class MyDate {

    private int day;
    private MyMonth month;
    private int year;
    public static DateFormat format;

    private boolean dateOk(int day, MyMonth month, int year) {
        if (day > 31) {
            return false;
        }
        if (day == 31
                && (month != MyMonth.JANUARY
                || month != MyMonth.MARCH
                || month != MyMonth.JULY
                || month != MyMonth.AUGUST
                || month != MyMonth.MAY
                || month != MyMonth.OCTOBER
                || month != MyMonth.DECEMBER)) {
            return false;
        }
        if (day == 29 && month == MyMonth.FEBRUARY && !isDisekto(year)) {
            return false;
        }
        return true;
    }

    public MyDate(int day, MyMonth month, int year) {
        if (!dateOk(day, month, year)) {
            throw new RuntimeException();
        }
        this.day = day;
        this.month = month;
        this.year = year;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    public int getDay() {
        return day;
    }

    public void setDay(int day) {
        this.day = day;
    }

    public MyMonth getMonth() {
        return month;
    }

    public void setMonth(MyMonth month) {
        this.month = month;
    }

    @Override
    public String toString() {
        if (format == DateFormat.GREEK) {
            return day + "/" + month + "/" + year;
        } else {
            return month + "-" + day + "-" + year;
        }
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 23 * hash + this.day;
        hash = 23 * hash + Objects.hashCode(this.month);
        hash = 23 * hash + this.year;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null || getClass() != obj.getClass()) {
            return false;
        }

        final MyDate other = (MyDate) obj;
        return (this.day == other.day && 
                this.year == other.year && 
                this.month == other.month);
    }

    public static boolean isDisekto(int year) {
        return (year % 400 == 0
                || (year % 4 == 0 && year % 100 != 0));
    }

    public boolean isDisekto() {
        return isDisekto(this.year);
    }

    public static void main(String[] args) {
        MyDate.format = DateFormat.GREEK;
        MyDate cDate = new MyDate(1, MyMonth.JANUARY, 2017);
        while (cDate.getYear() <= 2100) {
            System.out.println(cDate + (cDate.isDisekto() ? " is Disekto" : " is not Disekto"));
            cDate.setYear(cDate.getYear() + 1);
        }
    }
}
