package gr.ihu.cs.lmous.OOJ.k11.v1.x;

/**
 *
 * @author Lefteris Moussiades
 */
public class Triwnymo {

    private double a;
    private double b;
    private double g;

    public Triwnymo(double a, double b, double g) {
        if (a == 0) {
            throw new RuntimeException();
        }
        this.a = a;
        this.b = b;
        this.g = g;
    }

    public Triwnymo(double[] triwnymo) {
        this(triwnymo[0], triwnymo[1], triwnymo[2]);
    }

    public double diakrinousa() {
        return Math.pow(b, 2) - 4 * a * g;
    }

    public double x1() {
        double d = diakrinousa();
        if (d < 0) {
            return Double.NaN;
        }
        return (-b + Math.sqrt(d)) / (2 * a);
    }

    public double x2() {
        double d = diakrinousa();
        if (d < 0) {
            return Double.NaN;
        }
        return (-b - Math.sqrt(d)) / (2 * a);
    }

    public static void main(String[] args) {
        Triwnymo t1 = new Triwnymo(1, 2, 1);
        Triwnymo t2 = new Triwnymo(2, 9, 2);
        System.out.println("t1 Diakrinousa =" + t1.diakrinousa());
        System.out.println("t2 Diakrinousa =" + t2.diakrinousa());
        if (t1.diakrinousa() >= 0) {
            System.out.println("t1 x1= " + t1.x1());
            System.out.println("t1 x2= " + t1.x2());
        }
    }
}
