package gr.ihu.cs.lmous.OOJ.k11.v1.x;

public class WeightMeasurementUnit { //Κώδικας 11.13

    private String description;
    private double relationToGr;

    public WeightMeasurementUnit(String lekt, double relationToGr) {
        if (relationToGr <= 0) {
            throw new RuntimeException();
        }
        this.description = lekt;
        this.relationToGr = relationToGr;
    }

    public String getDescription() {
        return description;
    }

    public double getRelationToGr() {
        return relationToGr;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setRelationToGr(double relationToGr) {
        if (relationToGr <= 0) {
            throw new RuntimeException();
        }
        this.relationToGr = relationToGr;
    }

    @Override
    public int hashCode() {
        return Double.hashCode(this.relationToGr);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final WeightMeasurementUnit other = (WeightMeasurementUnit) obj;
        if (Double.compare(this.relationToGr, other.relationToGr) != 0) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "WeightMeasurementUnit{" + "description=" + description + ", relationToGr=" + relationToGr + '}';
    }

    public static void main(String[] args) {
        WeightMeasurementUnit kgr = new WeightMeasurementUnit("Kgr", 1000),
                metricTon = new WeightMeasurementUnit("Metric Ton", 1000000),
                mgr = new WeightMeasurementUnit("mgr", 1 / 1000d);
        System.out.println(kgr);
        System.out.println(metricTon);
        System.out.println(mgr);
    }
}
