/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v1.x.we1;

import java.util.ArrayList;
import java.util.Arrays;

public class Account {

    private final int id;
    private final AccountType type;
    private final ArrayList<Transaction> transactions = new ArrayList<>();
    private final ArrayList<Customer> dikaiouxoi = new ArrayList<>();

    Account(int id, AccountType type, Customer... dikaiouxoi) {
        this.id = id;
        this.type = type;
        this.dikaiouxoi.addAll(Arrays.asList(dikaiouxoi));
    }

    void addDikaiouxo(Customer p) {
        if (!dikaiouxoi.contains(p)) {
            dikaiouxoi.add(p);
        }
    }

    void removeDikaiouxo(Customer p) {
        dikaiouxoi.remove(p);
    }

    ArrayList<Customer> getDikaiouxoi() {
        return dikaiouxoi;
    }

    void addTransaction(Transaction t) {
        transactions.add(t);
    }

    @Override
    public String toString() {
        StringBuilder rVal= new StringBuilder(id +  " "+ type +", "+UI.dikaiouxoiStr()+": ");
        for (Customer c : dikaiouxoi) {
            rVal.append(" "+c.getName());
        }
        return rVal.toString();
    }

    public ArrayList<Transaction> getTransactions() {
        return transactions;
    }

    
    
}
