/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v1.x.we1;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;

public class Bank {

    private int lastAccountId = 0;
    private HashMap<Integer, Account> accounts = new HashMap<>();

    int createAccount(AccountType aType, Customer... dikaiouxoi) {
        lastAccountId++;
        accounts.put(lastAccountId, new Account(lastAccountId, aType, dikaiouxoi));
        for (Customer d : dikaiouxoi) {
            d.addAccount(lastAccountId);
        }
        return lastAccountId;
    }

    void addTransaction(Customer cust, Integer accountId, TType tType, double amount, String description) {
        Account account = null;
        if (cust.getAccounts().contains(accountId)) {
            account = accounts.get(accountId);
        }

        if (account != null) {
            ArrayList<Customer> dikaiouxoi = account.getDikaiouxoi();
            if (dikaiouxoi.contains(cust)) {
                account.addTransaction(new Transaction(tType, amount, description));
            }
        } else {
            if (UI.createAccount(cust)) {
                AccountType aType = UI.accountType();
                if (aType == null) {
                    UI.accountFail();
                    return;
                }
                int id = createAccount(aType, cust);
                addTransaction(cust, id, tType, amount, description);

            }
        }
    }

    void report() {
        Iterator<Entry<Integer, Account>> it = accounts.entrySet().iterator();
        while (it.hasNext()) {
            Account account = (Account) it.next().getValue();
            UI.prtAccount(account);
            double balance = 0;
            for (Transaction t : account.getTransactions()) {
                UI.prtString(t.toString());
                if (t.getType() == TType.CREDIT) {
                    balance += t.getAmount();
                } else {
                    balance -= t.getAmount();
                }
            }
            UI.prtBalance(balance);
            UI.endAccount();
        }
    }

    void report(Customer... dikaiouxoi) {
        Iterator<Entry<Integer, Account>> it = accounts.entrySet().iterator();
        while (it.hasNext()) {
            Account account = (Account) it.next().getValue();
            for (Customer c : dikaiouxoi) {
                if (account.getDikaiouxoi().contains(c)) {
                    UI.prtAccount(account);
                    double balance = 0;
                    for (Transaction t : account.getTransactions()) {
                        UI.prtString(t.toString());
                        if (t.getType() == TType.CREDIT) {
                            balance += t.getAmount();
                        } else {
                            balance -= t.getAmount();
                        }
                    }
                    UI.prtBalance(balance);
                    UI.endAccount();
                }
            }
        }
    }

}
