/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v1.x.we2;

import java.math.BigDecimal;
import java.util.ArrayList;

public class Customer {

    private String fName;
    private String sName;
    private final int id;
    private final ArrayList<Integer> accounts = new ArrayList<>();

    public Customer(int id, String fName, String sName) {
        this.fName = fName;
        this.sName = sName;
        this.id = id;
    }

    @Override
    public String toString() {
        return fName + " " + sName + ", id=" + id;
    }

    void addAccount(int i) {
        if (!accounts.contains(i)) {
            accounts.add(i);
        }
    }

    void withdrawal(Bank bank, int accountId, BigDecimal amount, String description) {
        bank.addTransaction(this, accountId, TType.DEBIT, amount, description);
    }

    void deposit(Bank bank, int accountId, BigDecimal amount, String description) {
        bank.addTransaction(this, accountId, TType.CREDIT, amount, description);
    }

    public ArrayList<Integer> getAccounts() {
        return accounts;
    }

    public int getAccount(int AA) {
        if (AA < accounts.size()) {
            return accounts.get(AA);
        }
        return -1;
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return fName + " " + sName;
    }
//   void getInfo(Bank bank) {
//       bank.report(this);
//   }

    public String getfName() {
        return fName;
    }

    public void setfName(String fName) {
        this.fName = fName;
    }

    public String getsName() {
        return sName;
    }

    public void setsName(String sName) {
        this.sName = sName;
    }

    void getInfo(Bank bank) {
        bank.report(this);
    }
}
