/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v1.x.we2;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Random;

public class Transaction {

    private final LocalDate date;
    private final TType type;
    private final BigDecimal amount;
    private final String description;

    public Transaction(TType type, BigDecimal amount, String description) {
        this.date = LocalDate.now().minusDays(new Random().nextInt(1000));
        this.type = type;
        this.amount = amount;
        this.description=description;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public LocalDate getDate() {
        return date;
    }

    public TType getType() {
        return type;
    }

    public String getDescription() {
        return description;
    }

    @Override
    public String toString() {
        return date + ", " + type + ", " + amount + ", " + description;
    }

    
    
   }
