/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k11.v2;

public class Rectangle { //Κωδικας 11.6

    private double length, width;

    public Rectangle(double len, double wid) { //Κώδικας 11.5
        if (len <= 0 || wid <= 0) {
            throw new IllegalArgumentException();
        }
        length = len;
        width = wid;
    }

    public Rectangle(double len) {
        if (len <= 0) {
            throw new IllegalArgumentException();
        }
        length = len;
        width = len;
    }

    public Rectangle() {
        length = 2;
        width = 2;
    }

    public double area() {
        return length * width;
    }

    public double perimeter() {
        return 2 * (length + width);
    }

    public double diagonal() {
        return Math.sqrt(Math.pow(length, 2) + Math.pow(width, 2));
    }

    public double getLength() {
        return length;
    }

    public void setLength(double len) {
        if (len <= 0) {
            throw new IllegalArgumentException();
        }
        length = len;
    }

    public double getWidth() {
        return width;
    }

    public void setWidth(double wid) {
        if (wid <= 0) {
            throw new IllegalArgumentException();
        }
        width = wid;
    }

    @Override
    public String toString() {
        return "Rect: ("+length+", "+width+")";
    }
}
