package gr.ihu.cs.lmous.OOJ.k12.v1.time;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.Period;
import java.time.format.DateTimeFormatter;
import java.time.format.FormatStyle;

/**
 *
 * @author Lefteris Moussiades
 */
public class Formatting {

    static void formatDate() { //Κώδικας 12.14
        DateTimeFormatter shortFormat = DateTimeFormatter.ofLocalizedDate(FormatStyle.SHORT);
        DateTimeFormatter mediumFormat = DateTimeFormatter.ofLocalizedDate(FormatStyle.MEDIUM);
        DateTimeFormatter longFormat = DateTimeFormatter.ofLocalizedDate(FormatStyle.LONG);
        DateTimeFormatter fullFormat = DateTimeFormatter.ofLocalizedDate(FormatStyle.FULL);
        LocalDate d = LocalDate.of(2021, 9,30);
        System.out.println(shortFormat.format(d));
        System.out.println(d.format(mediumFormat));
        System.out.println(d.format(longFormat));
        System.out.println(d.format(fullFormat));
    }

    static void formatTime() {//Κώδικας 12.15
        DateTimeFormatter shortFormat = DateTimeFormatter.ofLocalizedTime(FormatStyle.SHORT);
        DateTimeFormatter mediumFormat = DateTimeFormatter.ofLocalizedTime(FormatStyle.MEDIUM);
        LocalTime t = LocalTime.of(12, 50, 43);
        System.out.println(shortFormat.format(t));
        System.out.println(t.format(mediumFormat));

    }

    static void customFormat() { //Κώδικας 12.16
        LocalDate d = LocalDate.now();
        DateTimeFormatter f1 = DateTimeFormatter.ofPattern("MMMM, dd, yyyy");
        DateTimeFormatter f2 = DateTimeFormatter.ofPattern("dd/MM/yyyy");
        DateTimeFormatter f3 = DateTimeFormatter.ofPattern("dd-MMMM-yy");
        System.out.println(d.format(f2));
        System.out.println(d.format(f3));

        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("hh:mm:ss.nn a");
        LocalTime t = LocalTime.of(15,20,30,450);
        System.out.println(t.format(dtf));
        dtf = DateTimeFormatter.ofPattern("hh:mm a");
        System.out.println(t.format(dtf));
    }

    static void parsing() { //Κώδικας 12.17
        DateTimeFormatter fd = DateTimeFormatter.ofPattern("dd/MM/yyyy");
        DateTimeFormatter ft = DateTimeFormatter.ofPattern("hh:mm:ss");
        LocalDate d = LocalDate.parse("15/01/1987", fd);
        LocalTime t = LocalTime.parse("12:35:31", ft); 
        System.out.println(d);
        System.out.println(t);
    }

    static void chkCh3Q33() {
        LocalDateTime d = LocalDateTime.of(2015, 5, 10, 11, 22, 33);
        Period p = Period.ofDays(1).ofYears(2);
        d = d.minus(p);
        DateTimeFormatter f = DateTimeFormatter.ofLocalizedDateTime(FormatStyle.SHORT);
        System.out.println(d.format(f));
    }

    public static void main(String args[]) {
        customFormat();
        //formatDate();
        //formatTime();
        //parsing();

    }
}
