/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k12.v1.x;

import java.time.LocalDate;
import java.time.Month;
import java.util.LinkedList;

public class MyPriorityQueue {//Κώδικας 11.21

    private final LinkedList<Person>[] store;

    public MyPriorityQueue() {
        store = new LinkedList[3];
        store[Priority.LOW.ordinal()] = new LinkedList<>();
        store[Priority.NORMAL.ordinal()] = new LinkedList<>();
        store[Priority.HIGH.ordinal()] = new LinkedList<>();
    }

    public void add(Priority priority, Person person) {
        if (store[priority.ordinal()].contains(person)) {
            return;
        }
        store[priority.ordinal()].addLast(person);
    }

    public Person get() {
        if (!store[Priority.HIGH.ordinal()].isEmpty()) {
            return store[Priority.HIGH.ordinal()].removeFirst();
        }
        if (!store[Priority.NORMAL.ordinal()].isEmpty()) {
            return store[Priority.NORMAL.ordinal()].removeFirst();
        }
        if (!store[Priority.LOW.ordinal()].isEmpty()) {
            return store[Priority.LOW.ordinal()].removeFirst();
        }
        return null;
    }

    public static void main(String[] args) {
        Person p1 = new Person("A1", "Jim", "Black", LocalDate.of(1961, Month.MARCH, 1));
        Person p2 = new Person("A2", "Jack", "Blue", LocalDate.of(1967, Month.MARCH, 1));
        Person p3 = new Person("A3", "Jim", "Green", LocalDate.of(1971, Month.MARCH, 1));
        Person p4 = new Person("A4", "Mary", "White", LocalDate.of(1961, Month.MARCH, 1));
        Person p5 = new Person("A5", "Ann", "Red", LocalDate.of(1967, Month.MARCH, 1));
        Person p6 = new Person("A6", "Kelly", "Pink", LocalDate.of(1971, Month.MARCH, 1));
        MyPriorityQueue pQueue = new MyPriorityQueue();
        pQueue.add(Priority.LOW, p1);
        pQueue.add(Priority.LOW, p2);
        pQueue.add(Priority.NORMAL, p3);
        pQueue.add(Priority.NORMAL, p4);
        pQueue.add(Priority.HIGH, p5);
        pQueue.add(Priority.HIGH, p6);
        Person p;
        while ((p = pQueue.get()) != null) {
            System.out.println(p);
        }
    }

}
