/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k12.v1.x;

import java.time.LocalDate;
import java.time.Month;
import java.time.Period;

public class Person { // Κώδικας 12.19

    private final String id;
    private String fName;
    private String sName;
    private LocalDate birthday;
        
    public Person(String id, String fName, String sName, LocalDate birthday) {
        this.id = id;
        this.fName = fName;
        this.sName = sName;
        this.birthday = birthday;
    }

    public LocalDate getBirthday() {
        return birthday;
    }

    public void setBirthday(LocalDate birthday) {
        this.birthday = birthday;
    }

    public String getfName() {
        return fName;
    }

    public void setfName(String fName) {
        this.fName = fName;
    }

    public String getsName() {
        return sName;
    }

    public void setsName(String sName) {
        this.sName = sName;
    }

    public int getAge() {
        LocalDate today = LocalDate.now();
        return Period.between(birthday, today).getYears();
    }

    public String getId() {
        return id;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        return 17 * hash + this.id.hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Person other = (Person) obj;
        return this.id.equals(other.id);
    }

    @Override
    public String toString() {
        return fName + " " + sName + ", id=" + id;
    }

    public static void main(String[] args) {
        Person jim = new Person("A89132", "Jim", "Black", LocalDate.of(1971, Month.MARCH, 5));
        Person john = new Person("A89132", "John", "Black", LocalDate.of(1972, Month.APRIL, 5));
        System.out.println(jim + " is " + jim.getAge() + " years old ");
        System.out.println(john + " is " + john.getAge() + " years old ");
    }

}
