/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k13.v1;

public class Computer extends ElectricDevice { //Κώδικας 13.8

    private final Keyboard keyboard = new Keyboard();
    private final Memory memory = new Memory();
    private final Monitor monitor = new Monitor();

    void keyboardToMem() {
        if (!isPowerOn()) {
            return;
        }
        String data = keyboard.read();
        memory.setContent(data);
    }

    void memToMonitor() {
        if (!isPowerOn() || memory.isEmpty()) {
            return;
        }
        monitor.display(memory.getContent());
    }

    void clearMem() {
        memory.setContent(null);
    }

    public void operate() {
        clearMem();
        keyboardToMem();
        memToMonitor();
    }

    public static void main(String[] args) {
        Computer alfaX = new Computer();
        alfaX.setPowerOn(true);
        alfaX.operate();
        alfaX.setPowerOn(false);
    }
}
