/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k13.v1.x;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;

public class CalcMonthlyPayment { //Κώδικας 13.29

    public static void main(String[] args) {
        ArrayList<Employee> personel = new ArrayList<>();
        personel.add(new Clerk("1", "Jim", "Black", LocalDate.of(1967, Month.MARCH, 1)));
        personel.add(new Clerk("2", "John", "Blue", LocalDate.of(1972, Month.APRIL, 12)));
        personel.add(new Clerk("3", "Jack", "Dalton", LocalDate.of(1980, Month.MARCH, 21)));
        personel.add(new Manager(BigDecimal.valueOf(2000), "101", "Adam", "Smith", LocalDate.of(1980, Month.JANUARY, 12)));
        personel.add(new Manager(BigDecimal.valueOf(2200), "102", "Adam", "Smith", LocalDate.of(1980, Month.MARCH, 21)));
        Contributor cntr = new Contributor(BigDecimal.valueOf(12), "1001", "Kalamity", "Jane", LocalDate.of(2000, Month.MARCH, 21));
        cntr.setWorkingHours(120);
        personel.add(cntr);
        cntr = new Contributor(BigDecimal.valueOf(20), "1002", "Erick", "Erickson", LocalDate.of(2001, Month.MARCH, 21));
        cntr.setWorkingHours(140);
        personel.add(cntr);
        
        DecimalFormatSymbols dfs = new DecimalFormatSymbols();
        dfs.setDecimalSeparator('.');
        dfs.setGroupingSeparator(',');
        DecimalFormat f = new DecimalFormat("######.###");
        f.setDecimalFormatSymbols(dfs);

        for (Employee e : personel) {
            System.out.println(e.getId() + " " + e.getfName() + " " + e.getsName() + " " + f.format(e.earnings().doubleValue()));
        }
    }

}
