/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */

package gr.ihu.cs.lmous.OOJ.k13.v1.x;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.Period;
import java.util.Random;

public class Clerk extends Employee {//Κώδικας 13.27
    private static final BigDecimal BASESALARY=new BigDecimal(1200);
    private static final double INCREMENTRATE=0.05;
    private final LocalDate hireDate;

    public Clerk(String id, String fName, String sName, LocalDate birthday) {
        super(id, fName, sName, birthday);
        hireDate=LocalDate.now().minusDays(new Random().nextInt(10000));
    }
    
     
    @Override
    public BigDecimal earnings() {
        LocalDate today = LocalDate.now();
        int workingYears=Period.between(hireDate, today).getYears();
        BigDecimal incrementAmount=BASESALARY.multiply(new BigDecimal(workingYears*INCREMENTRATE));
        double d=incrementAmount.doubleValue();
        BigDecimal salary=BASESALARY.add(incrementAmount);
        return salary;
    }
}
