/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k13.v1.x2;

import java.util.ArrayList;
import java.util.Arrays;

public class MultipleChoice extends Question {// Κώδικας 13.23

    private final String text;
    private final ArrayList<String> answers;
    private final String correctAnswer;

    public MultipleChoice(String text,String correctAnswer, String...answers) {
        this.text = text;
        this.answers=new ArrayList<>(Arrays.asList(answers));
        this.correctAnswer=correctAnswer;
    }
    
    @Override
    public String getQuestion() {
        StringBuilder rVal=new StringBuilder();
        rVal.append(text+"\n");
        char label='A';
        for (String answer:answers) {
            rVal.append(label).append(". ").append(answer).append("\n");
            label++;
        }
        return rVal.toString();
    }

    @Override
    public boolean evaluateAnswer(String userAnswer) {
        return correctAnswer.equalsIgnoreCase(userAnswer);
    }

    public String getCorrectAnswer() {
        return correctAnswer;
    }

}
