/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k13_2.v1;

import gr.ihu.cs.lmous.OOJ.k13.v1.*;

public class Computer extends ElectricDevice { 

    private final Keyboard keyboard = new Keyboard();
    private final Memory memory = new Memory();
    private final Monitor monitor = new Monitor();

    private void connectToTransformer() { //Κώδικας 13.11
        System.out.println("connected");
    }
    
    @Override
    public void setPowerOn(boolean powerOn) { //Κώδικας 13.11
        if (powerOn) {
            connectToTransformer();
        }
        super.setPowerOn(powerOn);
    }

    void keyboardToMem() {
        if (!isPowerOn()) {
            return;
        }
        String data = keyboard.read();
        memory.setContent(data);
    }

    void memToMonitor() {
        if (!isPowerOn() || memory.isEmpty()) {
            return;
        }
        monitor.display(memory.getContent());
    }

    void clearMem() {
        memory.setContent(null);
    }

    public void operate() {
        clearMem();
        keyboardToMem();
        memToMonitor();
    }

    public static void main(String[] args) {
        Computer alfaX = new Computer();
        alfaX.setPowerOn(true);
        alfaX.operate();
        alfaX.setPowerOn(false);
        ElectricDevice betaX=new Computer();
        ((Computer)betaX).operate();
        
    }

}
