/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k13_3.v1;

public class SmartHome { //Κώδικας 13.14

    public static void switchOn(ElectricDevice[] homeElectrics) {
        for (ElectricDevice eD : homeElectrics) {
            eD.setPowerOn(true);
        }
    }

    public static void switchOff(ElectricDevice[] homeElectrics) {
        for (ElectricDevice eD : homeElectrics) {
            eD.setPowerOn(false);
        }
    }

    public static boolean checkDevices(ElectricDevice[] homeElectrics) {
        for (ElectricDevice eD : homeElectrics) {
            if (!eD.isPowerOn()) {
                return false;
            }
        }
        return true;
    }

    public static void operate(ElectricDevice[] homeElectrics) {
        for (ElectricDevice eD : homeElectrics) {
            eD.operate();
        }
    }

    public static void main(String[] args) {
        ElectricDevice[] homeElectrics = new ElectricDevice[4];
        homeElectrics[0] = new WashingMachine();
        homeElectrics[1] = new AirCondition();
        homeElectrics[2] = new Oven();
        homeElectrics[3] = new Computer();
        switchOn(homeElectrics);
        operate(homeElectrics);
        switchOff(homeElectrics);
        System.out.println(checkDevices(homeElectrics));
    }
}
