/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */

package gr.ihu.cs.lmous.OOJ.k14_1.v1;

import gr.ihu.cs.lmous.OOJ.k11.v1.x.Lib;
import java.util.Arrays;

public class Dice { //Κώδικας 14.6
    private final double[] distribution;
    
    public Dice(double[] distribution) {

        if (distribution.length != 6
                || !Lib.approximateEquals(Lib.sum(distribution), 1)) {
            throw new RuntimeException();
        }
        this.distribution = distribution;
    }
    
    public Dice() {
        distribution=new double[6];
        Arrays.fill(distribution, 1/6d);
    }

    public int roll() {
        double value = Lib.gen.nextDouble();
        double sum = 0;

        for (int i = 0; i < distribution.length; i++) {
            sum += distribution[i];
            if (value <= sum) {
                return i + 1;
            }
        }
        return 0;
    }
}
