/**
 * @author Lefteris Moussiades
 * @since 20/09/2015
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v1.x.TicTacToe;

/**
 * Είναι η κλάση που περιλαμβάνει την main
 * για αυτήν την εφαρμογή
 */
public class Game {

    Board board = new Board();
    Player p1;
    Player p2;

    /**
     * Δημιουργεί ένα παιχνίδι αποτελούμενο απο ένα ταμπλό και δύο παίκτες
     * Ενημερώνει κάθε παίκτη με τον αντίπαλό του.
     * @param p1 Player 1, αντίπαλος του Player 2
     * @param p2 Player 2, αντίπαλος του Player 1
     */
    Game(Player p1, Player p2) {
        this.p1 = p1;
        this.p2 = p2;
        p1.setOpponents(p2);
    }

    /**
     * Με βάση την board.win() ελέγχει αν υπάρχει νικητής
     *
     * @return Ο παίκτης που νίκησε ή null αν δεν υπάρχει νικητής
     * @see gr.ihu.cs.lmous.TicTacToe.Board#win()
     */
    Player winner() {
        char winnerSign = board.win();
        if (p1.getId() == winnerSign) {
            return p1;
        }
        if (p2.getId() == winnerSign) {
            return p2;
        }
        return null;
    }

    /**
     * Εκκινεί ένα παιχνίδι
     *
     * @param p Ο παίκτης που παίζει πρώτος
     * @return Τον νικητή ή null σε περίπτωση ισοπαλίας
     */
    Player play(Player p) {
        Player theWinner = null;
        Player current = p;

        do {
            Movement cell;
            if (board.freePositions() == 1) {
                board.autoMove(current);
            } else {
                cell = current.move(board);
                board.setPlayerMove(current, cell);
            }
            board.displayBoard();
            current = current.getOpponent();

        } while (board.freePositions() > 0
                && (theWinner = winner()) == null);

        return theWinner;
    }
    
     public static void main(String[] args)/*throws Exception*/ {
        Player p2 = new MiniMaxPlayer('Χ');
        Player p1 = new LPlayer('Ο');
        Player p3 = new RBPlayer('r');
        
        Game myGame = new Game(p2, p3);
        myGame.board.displayBoard();
        Player winner = myGame.play(p2);

        if (winner != null) {
            System.out.println("Winner is " + winner.getId());
        } else {
            System.out.println("withdraw ");
        }
    }

}
