/**
 * @author Lefteris Moussiades
 * @since 20/09/2015
 */

package gr.ihu.cs.lmous.OOJ.k14_1.v1.x.TicTacToe;

/**
 * Κληρονομεί την αφηρημένη κλάση Player. Υλοποιεί τον αλγόριθμο minimax  
 * Ο MiniMaxPlayer είναι τέλειος παίκτης. Δεν χάνει ποτέ.
 * https://www.youtube.com/watch?v=STjW3eH0Cik&t=76s&ab_channel=MITOpenCourseWare
 * @author Lefteris
 */
public class MiniMaxPlayer extends Player {
    Movement currentMovement;

    public MiniMaxPlayer(char id) {
        super(id);
    }
    
    private int maxIdx(int[] tbl)  {
        int rVal=0, max=tbl[0];
        for (int i=1; i<tbl.length; i++)
            if (tbl[i] > max) {
                max=tbl[i];
                rVal=i;
            }
        return rVal;
}


    private int minIdx(int[] tbl) {
        int rVal=0, min=tbl[0];
        for (int i=1; i<tbl.length; i++)
            if (tbl[i] < min) {
                min=tbl[i];
                rVal=i;
            }
        return rVal;
    }
    
    private int minimax(Board board, Player p) {
        if (getOpponent().wins(board))
           return -1;
        
        if (wins(board)) return 1;
        if (board.freePositions()==0) return 0;
        Movement[] moves= board.possibleMoves(); 
        int[]  scores = new int[moves.length];

        for (int i=0; i<moves.length; i++) {
            Board newState=new Board(board);
            newState.setPlayerMove(p, moves[i]);
            scores[i]=minimax(newState, p.getOpponent());
        }

        if (this.equals(p)) {
            int maxScoreIdx=maxIdx(scores);
            currentMovement=moves[maxScoreIdx];
            return scores[maxScoreIdx];
        }
        else {
            int minScoreIdx=minIdx(scores);
            currentMovement=moves[minScoreIdx];
            return scores[minScoreIdx];
        }
    }
    

/**
 * 
 * @param board
 * @return Κίνηση με βάση τον minimax 
 */
    @Override
    public Movement move(Board board) {
        minimax(board,this);
        return currentMovement;
    }
};




   