/**
 * @author Lefteris Moussiades
 * @since 20/09/2015
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v1.x.TicTacToe;

/**
 * Αφηρημένη κλάση που αναπαριστά ένα παίκτη Τρίλιζας. Όλες οι σαφείς κλάσεις
 * που αναπαριστούν παίκτες Τρίλιζας πρέπει να είναι παράγωγες της Player.
 */
public abstract class Player { // Κώδικας 14.21

    private final char id;
    private Player opponent;

    /**
     * Constructor
     *
     * @param id Η ταυτότητα του παίκτη, π.χ. x or o etc. Χρησιμοποιείται
     * επιπλέον κατά την επισήμανση των θεσεων του παίκτη στο ταμπλό
     *
     */
    public Player(char id) {
        this.id = id;
    }

    public char getId() {
        return id;
    }

    /**
     *
     * @param board
     * @return true Αν αυτός ο παίκτης έχει νικήσει
     */
    public boolean wins(Board board) {
        char wSign = board.win();
        return wSign == id;
    }

    /**
     * Ενημερώνει αυτόν τον παίκτη με τον αντίπαλό του. Ενημερώνει τον αντίπαλο
     * με αυτόν τον παίκτη
     *
     * @param p the opponent Player
     */
    public void setOpponents(Player p) {
        opponent = p;
        p.opponent = this;
    }

    public Player getOpponent() {
        return opponent;
    }

    /**
     * Όλες οι σαφείς κλάσεις παικτών Τρίλιζας πρέπει να υλοποιούν αυτήν την
     * μέθοδο
     *
     * @param par Λαμβάνει ως παράμετρο το ταμπλό της Τρίλιζας στην τρέχουσα
     * κατάσταση
     * @return Με βάση την τρέχουσα κατάσταση του ταμπλό, ο παίκτης "αποφασίζει"
     * την κίνησή του. Επιστρέφει αντικείμενο Movement
     */
    public abstract Movement move(Board par);

}
