/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v1.x.johnBeker;

import gr.ihu.cs.lmous.OOJ.k11.v1.x.Card;
import gr.ihu.cs.lmous.OOJ.k11.v1.x.CardRank;
import gr.ihu.cs.lmous.OOJ.k12.v1.x.Deck;
import gr.ihu.cs.lmous.OOJ.k12.v1.x.Person;
import gr.ihu.cs.lmous.OOJ.k14_1.v1.CardPlayerI;
import gr.ihu.cs.lmous.OOJ.k14_1.v1.Dice;
import gr.ihu.cs.lmous.OOJ.k14_1.v1.DicePlayerI;
import gr.ihu.cs.lmous.OOJ.k14_1.v1.Gambler;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Random;
import java.util.Set;

/**
 *
 * @author Lefteris
 */
public class DeckersMeeting {

    private static final Map<DicePlayerI, Integer> diceScores = new LinkedHashMap<>();
    private static final Dice fair = new Dice(new double[]{1. / 6, 1. / 6, 1. / 6, 1. / 6, 1. / 6, 1. / 6,});
    private static final Dice two6 = new Dice(new double[]{1. / 6, 1. / 6, 1. / 6, 1. / 6, 0, 1. / 3,});
    private static final Dice two5 = new Dice(new double[]{1. / 6, 1. / 6, 1. / 6, 0, 1. / 3, 1. / 6,});
    private static final Dice[] dices = new Dice[]{fair, two6, two5};
    private final static Random gen = new Random();

    static Dice pickDice() {
        return dices[gen.nextInt(3)];
    }

    private static void diceGame(DicePlayerI p1, DicePlayerI p2) {
        int score1 = 0;
        int score2 = 0;
        for (int i = 0; i < 10; i++) {
            int s1 = p1.roll(pickDice());
            int s2 = p2.roll(pickDice());
            if (s1 > s2) {
                score1 += s1;
            } else if (s2 > s1) {
                score2 += s2;
            }
        }

        Integer score = diceScores.get(p1);
        if (score == null) {
            score = 0;
        }
        diceScores.put(p1, score1 + score);

        score = diceScores.get(p2);
        if (score == null) {
            score = 0;
        }
        diceScores.put(p1, score2 + score);
    }

    private static void cardGame(Set<CardPlayerI> cardPlayers) {
        Deck deck = new Deck();
        deck.shuffle();
        while (!deck.empty()) {
            for (CardPlayerI cp : cardPlayers) {
                cp.pickTop(deck);
                if (deck.empty()) {
                    break;
                }
            }
        }
    }

    private static void meet(Person p1, Person p2, Set<CardPlayerI> cardPlayers) {
        if (p1 instanceof DicePlayerI && p2 instanceof DicePlayerI) {
            diceGame((DicePlayerI) p1, (DicePlayerI) p2);
        }

        if (p1 instanceof CardPlayerI) {
            cardPlayers.add((CardPlayerI) p1);
        }

        if (p2 instanceof CardPlayerI) {
            cardPlayers.add((CardPlayerI) p2);
        }
    }

    static int cntAces(ArrayList<Card> cards) {
        int rVal = 0;
        for (Card card : cards) {
            if (card.getCardRank() == CardRank.ACE) {
                rVal++;
            }
        }
        return rVal;
    }

    public static void main(String[] args) {
        Person[] persons = new Person[14];
        persons[0] = new DicePlayer("100", "Jack", "Antie", LocalDate.of(2001, Month.MARCH, 1));
        persons[1] = new DicePlayer("101", "John", "Travolta", LocalDate.of(1961, Month.AUGUST, 3));
        persons[2] = new DicePlayer("102", "Bill", "Allen", LocalDate.of(1980, Month.FEBRUARY, 4));
        persons[3] = new DicePlayer("103", "Jim", "Morison", LocalDate.of(2001, Month.JULY, 5));
        persons[4] = new DicePlayer("104", "Peter", "MacMillan", LocalDate.of(2002, Month.MARCH, 1));
        persons[5] = new DicePlayer("105", "George", "Best", LocalDate.of(1970, Month.MAY, 1));
        persons[6] = new DicePlayer("106", "George", "Blue", LocalDate.of(1980, Month.MAY, 1));
        persons[7] = new DicePlayer("107", "Beny", "Hill", LocalDate.of(1977, Month.JULY, 21));
        persons[8] = new CardPlayer("108", "John", "Beker", LocalDate.of(1977, Month.JULY, 23));
        persons[9] = new CardPlayer("109", "Alison", "Stair", LocalDate.of(1978, Month.APRIL, 22));
        persons[10] = new CardPlayer("110", "Erik", "Erikson", LocalDate.of(1979, Month.JANUARY, 13));

        persons[11] = new Gambler("111", "Erik", "Johnson", LocalDate.of(1989, Month.JANUARY, 13));
        persons[12] = new Gambler("112", "Klint", "Eastwood", LocalDate.of(1983, Month.FEBRUARY, 12));
        persons[13] = new Gambler("113", "Jane", "Fonda", LocalDate.of(1989, Month.JANUARY, 13));

        Set<CardPlayerI> cardPlayers = new HashSet<>();

        for (int i = 0; i < persons.length - 1; i++) {
            for (int j = i + 1; j < persons.length; j++) {
                meet(persons[i], persons[j], cardPlayers);
            }
        }

        cardGame(cardPlayers);

        Map<DicePlayerI, Integer> sortedScores = new LinkedHashMap<>();
        diceScores.entrySet().stream()
                .sorted(Map.Entry.<DicePlayerI, Integer>comparingByValue().reversed())
                .forEachOrdered(p -> sortedScores.put(p.getKey(), p.getValue()));
        //System.out.println(sortedScores);
        Set<DicePlayerI> keys = sortedScores.keySet();
        for (DicePlayerI dP : keys) {
            System.out.println(dP + "->" + sortedScores.get(dP));
        }

        System.out.println("");

        Map<CardPlayerI, ArrayList<Card>> opened = new LinkedHashMap<>();
        int maxAces = 0;
        for (CardPlayerI p : cardPlayers) {
            ArrayList<Card> cardsInHand = p.openCards();
            System.out.print(p + ":\n ");
            System.out.println(cardsInHand);
            opened.put(p, cardsInHand);
            int cAces = cntAces(cardsInHand);
            if (cAces > maxAces) {
                maxAces = cAces;
            }
        }

        ArrayList<CardPlayerI> winners = new ArrayList<>();
        for (CardPlayerI p : opened.keySet()) {
            int cAces = cntAces(opened.get(p));
            if (cAces == maxAces) {
                winners.add(p);
            }
        }
        System.out.println("-------------------------------------------------------");
        System.out.println("winner in card Game: \n" + winners + " Aces: " + maxAces);
    }

}
