/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v1.x1;

import gr.ihu.cs.lmous.OOJ.k11.v1.x.Card;
import gr.ihu.cs.lmous.OOJ.k11.v1.x.CardRank;
import gr.ihu.cs.lmous.OOJ.k11.v1.x.Suit;
import java.util.ArrayList;
import java.util.Collections;

public class AnyDeck {

    private final ArrayList<Card> deck=new ArrayList<>();
    
    private static CardRank next(CardRank current) {
        CardRank rVal=CardRank.values()[(current.ordinal() + 1) % CardRank.values().length];
        if (rVal.ordinal()<current.ordinal())
            return null;
        return rVal;
    }

    public AnyDeck(CardRank from, CardRank to) {
    
        for (CardRank r = from; r!=null && r.ordinal()<=to.ordinal(); r=next(r)) {
            for (Suit s : Suit.values()) {
                deck.add(new Card(r, s));
            }
        }
    }

    public void shuffle() {
        Collections.shuffle(deck);
    }

    public boolean empty() {
        return deck.isEmpty();
    }

    public Card pickCard() {
        return deck.remove(0);
    }

    @Override
    public String toString() {
        if (deck.isEmpty()) {
            return "Empty Deck";
        }
        return deck.toString();
    }

    public static void main(String[] args) {
        AnyDeck deck=new AnyDeck(CardRank.SEVEN, CardRank.SEVEN);
        System.out.println(deck);
    }
}
