package gr.ihu.cs.lmous.OOJ.k14_1.v1.x1;

public class ChemicalElement { //Κώδικας 14.19

    private final String symbol;
    private final int atomicNumber;
    private final int group;
    private final int period;
    private final char section;

    public ChemicalElement(int group, int period, char sector, int atomicNumber, String symbol) {
        this.group = group;
        this.period = period;
        this.section = sector;
        this.atomicNumber = atomicNumber;
        this.symbol = symbol;
    }

    public int getGroup() {
        return group;
    }

    public int getPeriod() {
        return period;
    }

    public char getSection() {
        return section;
    }

    public int getAtomicNumber() {
        return atomicNumber;
    }

    public String getSymbol() {
        return symbol;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + this.symbol.hashCode();
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ChemicalElement other = (ChemicalElement) obj;
        return this.symbol.equals(other.symbol);
    }

    @Override
    public String toString() {
        return symbol + ", AN=" + atomicNumber + ", group=" + group + ", period=" + period + ", sector=" + section;
    }

    
}
