/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v1.x1;

import gr.ihu.cs.lmous.OOJ.k11.v1.x.Card;
import gr.ihu.cs.lmous.OOJ.k11.v1.x.CardRank;
import gr.ihu.cs.lmous.OOJ.k11.v1.x.Suit;
import java.util.Random;

public class Deck32 implements Deck { //Κώδικας 14.14

    private final Card[] deck;
    private int cardsInDeck;
    private static final int DECKSIZE = 32;

    public Deck32() {
        deck = new Card[DECKSIZE];
        cardsInDeck = 0;
        for (int i = 5; i < 13; i++) {
            CardRank r = CardRank.values()[i];
            for (Suit s : Suit.values()) {
                deck[cardsInDeck++] = new Card(r, s);
            }
        }
    }

    @Override
    public void shuffle() {
        Random r = new Random();

        for (int i = 0; i < deck.length; i++) {
            int rIdx = r.nextInt(deck.length);
            Card tmp = deck[i];
            deck[i] = deck[rIdx];
            deck[rIdx] = tmp;
        }
    }

    @Override
    public boolean empty() {
        return cardsInDeck == 0;
    }

    @Override
    public Card pickTop() {
        cardsInDeck--;
        return deck[DECKSIZE - cardsInDeck - 1];
    }

    @Override
    public String toString() {
        if (cardsInDeck == 0) {
            return "Empty Deck";
        }
        StringBuilder rVal = new StringBuilder();
        for (int i = DECKSIZE - cardsInDeck; i < DECKSIZE; i++) {
            if (i > DECKSIZE - cardsInDeck && i % 4 == 0) {
                rVal.append("\n");
            }
            rVal.append(deck[i] + " ");
        }
        return rVal.toString();
    }

    public static void main(String[] args) {
        Deck32 deck = new Deck32();
        deck.shuffle();
        System.out.println(deck);
    }
}
