/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k14_1.v2;

public class ArrayListOfStrings { //Κώδικας 14.5

    private String[] store = new String[10];
    private int index = 0;

    private class ArrayListIterator implements MyIterator {

        private int current = 0;

        @Override
        public boolean hasNext() {
            return current < size();
        }

        @Override
        public String next() {
            return get(current++);
        }
    }

    private String[] increment(String[] store) {
        String[] rVal = new String[store.length + 10];
        System.arraycopy(store, 0, rVal, 0, store.length);
        return rVal;
    }

    public void add​(String s) {
        if (index == store.length) {
            store = increment(store);
        }
        store[index++] = s;
    }

    public String remove(int idx) {
        if (idx > index || idx < 0) {
            return null;
        }
        String rVal = store[idx];
        for (int i = idx; i < index; i++) {
            store[i] = store[i + 1];
        }
        index--;
        return rVal;
    }

    public String removeLast() {
        return remove(index - 1);
    }

    public String get(int idx) {
        if (idx >= index || idx < 0) {
            throw new IndexOutOfBoundsException();
        }
        return store[idx];
    }

    public boolean isEmpty() {
        return index == 0;
    }

    public int size() {
        return index;
    }

    public MyIterator myIterator() {
        return new ArrayListIterator();
    }

    public static void main(String[] args) {
        ArrayListOfStrings list = new ArrayListOfStrings();
        list.add("A");
        list.add("B");
        list.add("C");
        list.add("D");
        MyIterator it = list.myIterator();
        while (it.hasNext()) {
            System.out.print(it.next());
        }
        System.out.println();
    }

}
