/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k15.v1;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.time.LocalDate;
import java.time.Month;

public class RandomAccess {//Κώδικας 15.6

    public static Student read(RandomAccessFile f, int recNo) throws IOException {
        int records = (int) (f.length() / Student.RECSIZE);
        if (recNo < 0 || recNo >= records) {
            throw new RuntimeException("reading past of file end");
        }
        long pos = recNo * Student.RECSIZE;
        f.seek(pos);
        String s = f.readLine();
        Student student = StudentsToStdWidth.toStudent(s);
        return student;
    }

    public static void update(RandomAccessFile f, int recNo, Student student) throws IOException {
        int records = (int) (f.length() / Student.RECSIZE);
        if (recNo < 0 || recNo >= records) {
            throw new RuntimeException("updating past of file end");
        }
        long pos = recNo * Student.RECSIZE;
        f.seek(pos);
        f.writeBytes(student.toFixedWidth());
    }
    
    public static void append(RandomAccessFile f, Student student) throws IOException {
        f.seek(f.length());
        f.writeBytes(student.toFixedWidth()+"\n");
    }

    public static void main(String[] args) throws FileNotFoundException, IOException {
        RandomAccessFile f = new RandomAccessFile("data"+File.separator+"students.dat", "rw");
        Student student = read(f, 3);
        System.out.println(student);
        student.setfName("Mike");
        student.setsName("Updater");
        update(f, 3, student);
        student=new Student("999", "Jane", "Appender", LocalDate.of(1999,Month.MARCH,20));
        student.setScores(new double[]{14,15,16,17,18,19});
        append(f,student);
        append(f,student);
        f.close();
    }
}
