/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k15.v1;

import gr.ihu.cs.lmous.OOJ.k12.v1.x.Person;
import java.time.LocalDate;
import java.time.Month;
import java.util.Locale;

public class Student extends Person { //Κώδικας 15.2

    private final double[] scores = new double[Subject.values().length];
    public final static int RECSIZE = 69;

    public Student(String id, String fName, String sName, LocalDate birthday) {
        super(id, fName, sName, birthday);
    }

    public void setScore(Subject subject, double score) {
        scores[subject.ordinal()] = score;
    }

    public void setScores(double[] scores) {
        System.arraycopy(scores, 0, this.scores, 0, scores.length < this.scores.length ? scores.length : this.scores.length);
    }

    public double getScore(Subject subject) {
        return scores[subject.ordinal()];
    }

    @Override
    public String toString() {
        return getId() + " " + getfName() + " " + getsName()
                + String.format(Locale.US, "%5.1f", getScore(Subject.MATH))
                + String.format(Locale.US, "%5.1f", getScore(Subject.HISTORY))
                + String.format(Locale.US, "%5.1f", getScore(Subject.LANGUAGE))
                + String.format(Locale.US, "%5.1f", getScore(Subject.CHEMISTRY))
                + String.format(Locale.US, "%5.1f", getScore(Subject.PHYSICS))
                + String.format(Locale.US, "%5.1f", getScore(Subject.BIOLOGY))
                + " " + getBirthday();
    }

    public String toFixedWidth() {
        return String.format("%4s", getId())
                + String.format("%15s", getfName())
                + String.format("%15s", getsName())
                + String.format(Locale.US, "%4.1f", getScore(Subject.MATH))
                + String.format(Locale.US, "%4.1f", getScore(Subject.HISTORY))
                + String.format(Locale.US, "%4.1f", getScore(Subject.LANGUAGE))
                + String.format(Locale.US, "%4.1f", getScore(Subject.CHEMISTRY))
                + String.format(Locale.US, "%4.1f", getScore(Subject.PHYSICS))
                + String.format(Locale.US, "%4.1f", getScore(Subject.BIOLOGY))
                + getBirthday();
    }

    public static void main(String[] args) {
        Student s = new Student("1", "Jim", "Black", LocalDate.of(1976, Month.MARCH, 4));
        s.setScore(Subject.PHYSICS, 98);
        s.setScore(Subject.MATH, 100);
        System.out.println(s);
        System.out.println(s.toFixedWidth());
    }

}
