/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k15.v1;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;
import java.util.Scanner;

public class StudentsDelimited { //Κώδικας 15.3

    static void createStudents(String fName) throws IOException {
        File file = new File(fName);
        BufferedWriter out = new BufferedWriter(new FileWriter(file));
        Student jim = new Student("113", "Jim", "Blue", LocalDate.of(2005, Month.APRIL, 1));
        jim.setScores(new double[]{10, 11, 12, 13, 14, 15});
        Student jack = new Student("212", "Jack", "Green", LocalDate.of(2005, Month.MAY, 1));
        jack.setScores(new double[]{11, 12, 13, 14, 15, 16});
        Student mary = new Student("111", "Mary", "Red", LocalDate.of(2005, Month.JUNE, 1));
        mary.setScores(new double[]{12, 13, 14, 15, 16, 17});
        Student kely = new Student("201", "Kely", "Green", LocalDate.of(2005, Month.JULY, 1));
        kely.setScores(new double[]{13, 14, 15, 16, 17, 18});
        out.write(jim + "\n");
        out.write(jack + "\n");
        out.write(mary + "\n");
        out.write(kely + "\n");

        out.close();
    }

    static ArrayList<Student> readStudents(String fName) throws FileNotFoundException {
        ArrayList<Student> rVal = new ArrayList<>();
        File input = new File(fName);
        Scanner scanner = new Scanner(input);
        while (scanner.hasNextLine()) {
            String st = scanner.nextLine();
            String[] stFields = st.split(" ");
            Student student = new Student(stFields[0], stFields[1], stFields[2], LocalDate.parse(stFields[9]));
            student.setScore(Subject.MATH, Double.parseDouble(stFields[3]));
            student.setScore(Subject.HISTORY, Double.parseDouble(stFields[4]));
            student.setScore(Subject.LANGUAGE, Double.parseDouble(stFields[5]));
            student.setScore(Subject.CHEMISTRY, Double.parseDouble(stFields[6]));
            student.setScore(Subject.PHYSICS, Double.parseDouble(stFields[7]));
            student.setScore(Subject.BIOLOGY, Double.parseDouble(stFields[8]));
            rVal.add(student);
        }
        scanner.close();
        return rVal;
    }

    public static void main(String[] args) throws IOException {
        String fName = "data" + File.separator + "studentsd.dat";
        createStudents(fName);
        ArrayList<Student> students = readStudents(fName);
        for (Student st : students) {
            System.out.println(st);
        }
    }
}
