package gr.ihu.cs.lmous.OOJ.k15.v1;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;
import java.util.Scanner;

public class StudentsToStdWidth { //Κώδικας 15.4

    static void createStudents(String fName) throws IOException {
        File file = new File(fName);
        BufferedWriter out = new BufferedWriter(new FileWriter(file));
        Student jim = new Student("113", "Jim", "Blue", LocalDate.of(2005, Month.MARCH, 1));
        jim.setScores(new double[]{10, 11, 12, 13, 14, 15});
        Student jack = new Student("212", "Jack", "Green", LocalDate.of(2005, Month.MARCH, 2));
        jack.setScores(new double[]{11, 12, 13, 14, 15, 16});
        Student mary = new Student("911", "Mary", "Red", LocalDate.of(2005, Month.MARCH, 3));
        mary.setScores(new double[]{12, 13, 14, 15, 16, 17});
        Student kely = new Student("201", "Kely", "Green", LocalDate.of(2005, Month.MARCH, 4));
        kely.setScores(new double[]{13, 14, 15, 16, 17, 18});
        out.write(jim.toFixedWidth() + "\n");
        out.write(jack.toFixedWidth() + "\n");
        out.write(mary.toFixedWidth() + "\n");
        out.write(kely.toFixedWidth() + "\n");
        out.close();
    }

    public static Student toStudent(String st) {
        Student student = new Student(st.substring(0, 4).trim(),
                st.substring(4, 19).trim(),
                st.substring(19, 34).trim(),
                LocalDate.parse(st.substring(58))
        );
        student.setScore(Subject.MATH, Double.parseDouble(st.substring(34, 38).trim()));
        student.setScore(Subject.HISTORY, Double.parseDouble(st.substring(38, 42).trim()));
        student.setScore(Subject.LANGUAGE, Double.parseDouble(st.substring(42, 46).trim()));
        student.setScore(Subject.CHEMISTRY, Double.parseDouble(st.substring(46, 50).trim()));
        student.setScore(Subject.PHYSICS, Double.parseDouble(st.substring(50, 54).trim()));
        student.setScore(Subject.BIOLOGY, Double.parseDouble(st.substring(54, 58).trim()));
        return student;
    }

    static ArrayList<Student> readStudents(String fName) throws FileNotFoundException {
        ArrayList<Student> rVal = new ArrayList<>();
        File input = new File(fName);
        Scanner scanner = new Scanner(input);
        while (scanner.hasNextLine()) {
            String st = scanner.nextLine();
            Student student = toStudent(st);
            rVal.add(student);
        }
        scanner.close();
        return rVal;
    }

    public static void main(String[] args) throws IOException {
        createStudents("data" + File.separator + "students.dat");
        ArrayList<Student> students = readStudents("data" + File.separator + "students.dat");
        System.out.println(students);
    }
}
