package gr.ihu.cs.lmous.OOJ.k15.v1.x;

import java.io.File;
import java.util.Locale;

public class Directory { //Κώδικας 15.14

    public static String convertBytes(long bytes) {
        String rVal;
        long kB = bytes / 1024;
        long mB = bytes / (long) Math.pow(1024, 2);
        long gB = bytes / (long) Math.pow(1024, 3);
        if (gB > 0) {
            rVal = gB + " GB";
        } else if (mB > 0) {
            rVal = mB + " MB";
        } else if (kB > 0) {
            rVal = kB + " KB";
        } else {
            rVal = bytes + " B";
        }
        return rVal;
    }

    public static void dirRecurse(File root) {
        if (root.isDirectory()) {
            System.out.println("   Directory: " + root.getAbsolutePath());
            showFiles(root.listFiles());
        } else {
            System.out.println((root.isHidden() ? "h" : "-")
                    + (root.canRead() ? "r" : "-")
                    + (root.canWrite() ? "w" : "-")
                    + String.format(Locale.US, "%10s", convertBytes(root.length()))
                    + "      " + root.getName());
        }
    }

    public static void showFiles(File[] files) {
        for (File file : files) {
            if (file.isDirectory()) {
                System.out.println("");
                System.out.println("   Directory: " + file.getAbsolutePath());
                showFiles(file.listFiles()); // Calls same method again.
            } else {
                System.out.println((file.isHidden() ? "h" : "-")
                        + (file.canRead() ? "r" : "-")
                        + (file.canWrite() ? "w" : "-")
                        + String.format(Locale.US, "%10s", convertBytes(file.length()))
                        + "      " + file.getName());
            }
        }
    }

    public static void main(String[] args) {
        File root = new File("data");
        dirRecurse(root);
    }
}
