/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k15.v1.x;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class Grep {

    private static List<String> fileToString(File filePath) throws FileNotFoundException {
        ArrayList<String> rVal = new ArrayList<>();
        Scanner scanner = new Scanner(filePath);
        while (scanner.hasNextLine()) {
            rVal.add(scanner.nextLine());
        }
        scanner.close();
        return rVal;
    }

    private static boolean contains(List<String> fLines, String searchitem) {
        Iterator<String> it = fLines.iterator();
        while (it.hasNext()) {
            String cLine = it.next();
            if (cLine.contains(searchitem)) {
                return true;
            }
        }
        return false;
    }

    private static void find(List<String> fLines, String searchitem) {
        for (int i = 0; i < fLines.size(); i++) {
            String cLine = fLines.get(i);
            if (cLine.contains(searchitem)) {
                System.out.println("(" + (i+1) + ") " + cLine);
            }
        }
    }

    public static void grep(File[] files, String searchItem) throws FileNotFoundException {
        String prFile = "";
        for (File file : files) {
            if (file.isDirectory()) {
                grep(file.listFiles(), searchItem); // Calls same method again.
            } else {
                List<String> content = fileToString(file);
                if (!file.getName().equals(prFile) && contains(content, searchItem)) {
                    System.out.println(file.getName());
                    prFile = file.getName();
                }
                find(content, searchItem);
            }
        }
    }

    public static void grep(File file, String searchItem) throws FileNotFoundException {
        if (file.isFile()) {
            System.out.println(file.getName());
            List<String> content = fileToString(file);
            find(content, searchItem);
        } else {
            grep(file.listFiles(), searchItem);
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        File root = new File("data");
        grep(root, "Jim");
    }
}
