/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k15.v2;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.time.Duration;
import java.time.LocalTime;

public class BinaryData {

    private static final String INPUT = "data"+File.separator+"sunset.jpg";
    private static final String OUTPUT = "data"+File.separator+"sunsetcopy.jpg";
    private static final String OUTPUTF = "data"+File.separator+"sunsetcopyf.jpg";

    public static void readBinary() throws FileNotFoundException, IOException {
        FileInputStream in = new FileInputStream(new File(INPUT));
        FileOutputStream out = new FileOutputStream(OUTPUT);
        int data;
        while (true) {
            data = in.read();
            if (data == -1) {
                break;
            } else {
                out.write(data);
            }
        }
        in.close();
        out.close();
    }

    public static void copyBinary() throws FileNotFoundException, IOException {
        LocalTime start=LocalTime.now();
        FileInputStream in = new FileInputStream(new File(INPUT));
        FileOutputStream out = new FileOutputStream(OUTPUT);
        int data;
        while (true) {
            data = in.read();
            if (data == -1) {
                break;
            } else {
                out.write(data);
            }
        }
        in.close();
        out.close();
        LocalTime end=LocalTime.now();
        System.out.println("copyBinary "+Duration.between(start, end));
    }

    public static void copyBinaryFast() throws FileNotFoundException, IOException {
        LocalTime start=LocalTime.now();
        BufferedInputStream in = new BufferedInputStream(new FileInputStream(new File(INPUT)));
        BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(OUTPUTF));
        int data;
        while (true) {
            data = in.read();
            if (data == -1) {
                break;
            } else {
                out.write(data);
            }
        }
        in.close();
        out.close();
        LocalTime end=LocalTime.now();
        System.out.println("copyBinaryFast "+Duration.between(start, end));
    }

    public static void main(String[] args) throws IOException {
        copyBinary();
        copyBinaryFast();
    }
}
