/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k16.v1;

import gr.ihu.cs.lmous.OOJ.k15.v1.Student;
import gr.ihu.cs.lmous.OOJ.k15.v1.Subject;
import java.io.File;
import java.io.FileNotFoundException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Scanner;

public class UserDefined {

    static Student create(String[] field) {
        Student student = new Student(field[0], field[1], field[2], LocalDate.parse(field[9]));
        student.setScore(Subject.MATH, Double.parseDouble(field[3]));
        student.setScore(Subject.HISTORY, Double.parseDouble(field[4]));
        student.setScore(Subject.LANGUAGE, Double.parseDouble(field[5]));
        student.setScore(Subject.CHEMISTRY, Double.parseDouble(field[6]));
        student.setScore(Subject.PHYSICS, Double.parseDouble(field[7]));
        student.setScore(Subject.BIOLOGY, Double.parseDouble(field[8]));
        return student;
    }

    static ArrayList<Student> readStudents(String fName) { //Κώδικας 16.10
        ArrayList<Student> rVal = new ArrayList<>();
        File input = new File(fName);
        int ln = 0;
        try ( Scanner scanner = new Scanner(input);) {
            while (scanner.hasNextLine()) {
                ln++;
                String st = scanner.nextLine();
                String[] stFields = st.split(" ");
                if (stFields.length != 10) {
                    throw new MallFormedFileLine(ln);
                }
                Student student = create(stFields);
                rVal.add(student);
            }
        } catch (FileNotFoundException ex) {
            System.out.println(ex + ": " + fName);
        } catch (MallFormedFileLine e) {
            System.out.println("Format Error at line: " + e.getLine());
        }
        return rVal;
    }

    static ArrayList<Student> readStudentsC(String fName) { //Κώδικας 16.11
        ArrayList<Student> rVal = new ArrayList<>();
        File input = new File(fName);
        Scanner scanner = null;
        Scanner keyboard=new Scanner(System.in);
        try {
            scanner = new Scanner(input);
        } catch (FileNotFoundException ex) {
            System.out.println(ex + ": " + fName);
            System.exit(1);
        }
        int ln = 0;
        while (true) {
            ln++;
            try {
                if (!scanner.hasNextLine()) 
                    break;
                String st = scanner.nextLine();
                String[] stFields = st.split(" ");
                if (stFields.length != 10) {
                    throw new MallFormedFileLine(ln);
                }
                Student student = create(stFields);
                rVal.add(student);

            } catch (MallFormedFileLine | NumberFormatException e) {
                System.out.println(e);
                System.out.println("Continue reading Y/N? ");
                String userAnswer = keyboard.nextLine();
                if (userAnswer.equals("N")) {
                    scanner.close();
                    System.exit(1);
                }
            }
        }
        scanner.close();
        return rVal;
    }

    public static void main(String[] args) {
        String fName = "data" + File.separator + "studentsd.dat";
        ArrayList<Student> students = readStudentsC(fName);
        System.out.println(students);
    }
}
