/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k16.x;

import gr.ihu.cs.lmous.OOJ.k11.v1.x.Lib;

public class QuadraticEquation { //Κώδικας 16.13

    private final double a, b, c;

    public QuadraticEquation(double a, double b, double c) {
        if (Lib.approximateEquals(a, 0)) {
            throw new IllegalArgumentException();
        }
        this.a = a;
        this.b = b;
        this.c = c;
    }

    public QuadraticEquation(double a, double b) {
        this(a, b, 0);
    }

    public QuadraticEquation(double a) {
        this(a, 0, 0);
    }

    public double discriminant() {
        return Math.pow(b, 2) - 4 * a * c;
    }

    @Override
    public String toString() {
        return "QuadraticEquation{" + "a=" + a + ", b=" + b + ", c=" + c + '}';
    }

    
    public double x1() {
        double disc = discriminant();
        if (disc < 0) {
            throw new RuntimeException(this+", discriminant < 0");
        }
        return (-b + Math.sqrt(disc)) / (2 * a);
    }
    
    public double x2() {
        double disc = discriminant();
        if (disc < 0) {
            throw new RuntimeException(this+", discriminant < 0");
        }
        return (-b - Math.sqrt(disc)) / (2 * a);
    }
    
    public static void main(String[] args) {
        QuadraticEquation qE1=new QuadraticEquation(2,4,6),
                qE2=new QuadraticEquation(1,4),
                qE3=new QuadraticEquation(2);
        System.out.println(qE1.discriminant());
        System.out.println(qE2.discriminant());
        System.out.println(qE3.discriminant());
        System.out.println(qE1.x1()+" "+qE1.x2());
        System.out.println(qE2.x1()+" "+qE2.x2());
        System.out.println(qE3.x1()+" "+qE3.x2());
        
        QuadraticEquation qE=new QuadraticEquation(1, 1, -1);
        System.out.println(qE.discriminant());
        System.out.println(qE.x1()+" "+qE.x2());
    }
}
