/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k17.v1;

import java.util.Arrays;

class Tmp implements Comparable<Tmp> { // Κώδικας 17.12

    private final String id;
    private final String description;

    public Tmp(String id, String description) {
        this.id = id;
        this.description = description;
    }

    @Override
    public int compareTo(Tmp o) {
        return id.compareTo(o.id);
    }

    @Override
    public String toString() {
        return id;
    }
}

public class SortX {

    private static <E> void swap(E[] a, int i, int j) { //  Κώδικας 17.11
        if (i != j) {
            E temp = a[i];
            a[i] = a[j];
            a[j] = temp;
        }
    }

    public static <E extends Comparable<E>> void sort(E[] a) { // Κώδικας 17.11
        for (int i = 0; i < a.length - 1; i++) {
            int smallest = i;
            for (int j = i + 1; j < a.length; j++) {
                if (a[j].compareTo(a[smallest]) <= 0) {
                    smallest = j;
                }
            }
            swap(a, i, smallest);  
        }
    }

    public static void main(String[] args) {
        Integer[] ints = new Integer[10];
        Double[] doubles = new Double[10];
        Tmp[] tmps = new Tmp[10];
        Comparable[] l=new Comparable[3];
        l[0]=10;
        l[1]=22;
        l[2]=3;//new Tmp(Integer.toString(1), Integer.toString(2));
        
        for (int i = 0; i < 10; i++) {
            doubles[i] = 10d - i;
            ints[i] = 10 - i;
            tmps[i] = new Tmp(Integer.toString(10 - i), Integer.toString(10 - i));
        }
        sort(l);
        sort(ints);
        sort(doubles);
        sort(tmps);
        System.out.println(Arrays.asList(ints));
        System.out.println(Arrays.asList(doubles));
        System.out.println(Arrays.asList(tmps));
    }
}
