/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */

package gr.ihu.cs.lmous.OOJ.k17.x;

import java.util.ArrayList;

public class TwoDimension<T> {
    private final ArrayList<T> store;
    private final int rows;
    private final int clmns;

    public TwoDimension(int rows, int clmns) {
        this.store = new ArrayList<>(rows*clmns);
        for (int i=0; i<rows*clmns; i++)
            store.add(null);
        this.rows=rows;
        this.clmns=clmns;
    }
    
    public T set(int row, int clmn, T element) {
        return store.set(row*clmns+clmn, element);
    }
    
    public T get(int row, int clmn) {
        return store.get(row*clmns+clmn);
    }
    
    public static void main(String[] args) {
        ArrayList<Integer> l=new ArrayList<>(15);
        TwoDimension<Integer> t=new TwoDimension<>(5,3);
        for (int i=0; i<t.getRows(); i++)
            for (int j=0; j<t.getClmns(); j++) {
                t.set(i, j, i*3+j);
            }
        for (int i=0; i<t.getRows(); i++)
            for (int j=0; j<t.getClmns(); j++) {
                System.out.println(t.get(i, j));
            }
        
    }

    public int getRows() {
        return rows;
    }

    public int getClmns() {
        return clmns;
    }

}
