/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k18.v1;

import gr.ihu.cs.lmous.OOJ.k12.v1.x.Person;
import static gr.ihu.cs.lmous.OOJ.k14_1.v1.PolymorphismDemo.loadData;
import java.util.Iterator;
import java.util.List;
import java.util.function.Predicate;

/**
 *
 * @author lmous
 */
class SelectorGreater50 implements Predicate<Person> { //Κώδικας 18.2

    @Override
    public boolean test(Person t) {
        return t.getAge() > 50;
    }
}

class SelectorBetween20and30 implements Predicate<Person> { //Κώδικας 18.2

    @Override
    public boolean test(Person t) {
        return t.getAge() >= 40 && t.getAge() <= 55;
    }
}

public class PredicateNonLambda {

    static void prt(List<Person> list, Predicate<Person> choice) { //Κώδικας 18.1
        Iterator<Person> it = list.iterator();
        while (it.hasNext()) {
            Person p = it.next();
            if (choice.test(p)) {
                System.out.println(p + " " + p.getAge());
            }
        }
    }

    public static void main(String[] args) { //Κώδικας 18.3
        List<Person> list = loadData();
        prt(list, new SelectorGreater50());
        System.out.println("-------------------");
        prt(list, new SelectorBetween20and30());
    }
}
