package gr.ihu.cs.lmous.OOJ.k18.x;

import java.util.HashMap;

/**
 *
 * @author Lefteris Moussiades <lmous@teiemt.gr>
 */
class Tupple {//Κώδικας 18.12

    double b;
    int e;

    public Tupple(double b, int e) {
        this.b = b;
        this.e = e;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 43 * hash + (int) this.b;
        hash = 43 * hash + this.e;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Tupple other = (Tupple) obj;
        if (this.b != other.b) {
            return false;
        }
        return (int) this.e == (int) other.e;
    }

}

public class Power {

    static long cnt1 = 0;
    static long cnt2 = 0;
    static HashMap<Tupple, Double> mem = new HashMap<>();

    static double pow(int b, int e) {
        cnt1++;
        if (e > 0) {
            return b * pow(b, e - 1);
        } else if (e < 0) {
            return 1 / pow(b, -e);
        }
        return 1;
    }

    static double fastPow(int b, int e, HashMap<Tupple, Double> mem) {
        cnt2++;
        if (e != 0) {
            try {
                return mem.get(new Tupple(b, e));
            } catch (Exception x) {
                double rslt;
                if (e > 0) {
                    rslt = b * fastPow(b, e - 1, mem);
                } else {
                    rslt = 1 / fastPow(b, -e, mem);
                }
                mem.put(new Tupple(b, e), rslt);
                return rslt;
            }
        }
        return 1;
    }

    static void test() {
        cnt1=0;
        cnt2=0;
        System.out.println("pow(2,16)=" + pow(2, 16));
        System.out.println("fastpow(2,16)=" + fastPow(2, 16, mem));
        System.out.println(cnt1 + " " + cnt2);
    }

    public static void main(String[] args) {
        test();
        System.out.println("----------");
        test();
    }
}
