/*
 * Κώδικας 7.25
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k7.v1.x;

public class MyArrays {

    public static int seqSearch(int[] t, int sE) {
        for (int i = 0; i < t.length; i++) {
            if (t[i] == sE) {
                return i;
            }
        }
        return -1;
    }

    public static int seqSearch(String[] t, String sE) {
        for (int i = 0; i < t.length; i++) {
            if (t[i].equals(sE)) {
                return i;
            }
        }
        return -1;
    }

    public static int cntOccurances(int[] t, int sE) {
        int cnt = 0;
        for (int e : t) {
            if (e == sE) {
                cnt++;
            }
        }
        return cnt;
    }

    public static String toString(int[] t) {
        if (t.length == 0) {
            return "[]";
        }
        String s = "[";
        for (int i = 0; i < t.length; i++) {
            s += t[i];
            if (i < t.length - 1) {
                s += ", ";
            }
        }
        s += "]";
        return s;
    }

    public static String toString(int[][] t) {
        if (t.length == 0) {
            return "[]";
        }
        String s = "[";
        for (int i = 0; i < t.length; i++) {
            s += toString(t[i]);
            if (i < t.length - 1) {
                s += ",\n";
            }
        }
        s += "]";
        return s;
    }

    public static int[] reverse(int[] input) {
        int[] rVal = new int[input.length];
        for (int i = 0; i < input.length; i++) {
            rVal[rVal.length - 1 - i] = input[i];
        }
        return rVal;
    }

    public static int sum(int[] t) {
        int sum = 0;
        for (int i : t) {
            sum += i;
        }
        return sum;
    }

    public static int max(int[] t) {
        int max = t[0];
        int idx = 0;
        for (int i = 1; i < t.length; i++) {
            if (t[i] > max) {
                idx = i;
                max = t[i];
            }
        }
        return idx;
    }

    public static boolean equals(int[] tA, int[] tB) {
        if (tA.length != tB.length) {
            return false;
        }
        for (int cE : tA) {
            if (seqSearch(tB, cE) == -1) {
                return false;
            }
        }
        return true;
    }

    public static boolean equals(String[] tA, String[] tB) {
        if (tA.length != tB.length) {
            return false;
        }
        for (String cE : tA) {
            if (seqSearch(tB, cE) == -1) {
                return false;
            }
        }
        return true;
    }

    public static int binarySearch(int[] tbl, int schElement) {
        int from = 0, to = tbl.length - 1, mid = (to - from) / 2;
        while (to >= from) {
            if (tbl[mid] == schElement) {
                return mid;
            } else if (schElement < tbl[mid]) {
                to = mid - 1;
            } else {
                from = mid + 1;
            }
            mid = from + (to - from) / 2;
        }
        return -1;
    }

    public static void swap(int[] t, int idx1, int idx2) {
        int i = t[idx1];
        t[idx1] = t[idx2];
        t[idx2] = i;
    }

    public static int idxOfMin(int[] t, int startIdx) {
        int min = t[startIdx];
        int rVal = startIdx;
        for (int i = startIdx + 1; i < t.length; i++) {
            if (t[i] < min) {
                min = t[i];
                rVal = i;
            }
        }
        return rVal;
    }

    public static void sort(int[] t) {
        for (int i = 0; i < t.length; i++) {
            int mIdx = idxOfMin(t, i);
            if (mIdx != i) {
                swap(t, mIdx, i);
            }
        }
    }

}
