/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k7.v1.x;

public class NumericalSystems {

    private static int parseDigit(String digit) {
        switch (digit) {
            case "A":
                return 10;
            case "B":
                return 11;
            case "C":
                return 12;
            case "D":
                return 13;
            case "E":
                return 14;
            case "F":
                return 15;
        }
        return Integer.parseInt(digit);
    }

    private static String parseDigit(int digit) {
        switch (digit) {
            case 10:
                return "A";
            case 11:
                return "B";
            case 12:
                return "C";
            case 13:
                return "D";
            case 14:
                return "E";
            case 15:
                return "F";
        }
        return Integer.toString(digit);
    }

    public static double toDecimal(String number, String base) {
        int comaPos = number.indexOf('.');
        String intPart = null, decPart = null;
        if (comaPos < 0) {
            intPart = number;
        } else {
            intPart = number.substring(0, comaPos);
            decPart = number.substring(comaPos + 1);
        }

        double rVal = 0;
        int lBase = Integer.parseInt(base);
        int k = intPart.length();
        for (int i = 0; i < k; i++) {
            int digit = parseDigit(intPart.substring(i, i + 1));
            rVal += digit * Math.pow(lBase, k - i - 1);
        }
        if (decPart == null) {
            return rVal;
        }
        k = decPart.length();
        for (int i = 0; i < k; i++) {
            int digit = parseDigit(decPart.substring(i, i + 1));
            rVal += digit * Math.pow(lBase, -i - 1);
        }
        return rVal;
    }

    public static String fromDec(String decNum, String toBase) {
        int comaPos = decNum.indexOf('.');
        String intPart = null, decPart = null;
        if (comaPos < 0) {
            intPart = decNum;
        } else {
            intPart = decNum.substring(0, comaPos);
            decPart = decNum.substring(comaPos + 1);
        }
        int base = Integer.parseInt(toBase);
        int quotient = Integer.parseInt(intPart);
        int remainder;
        StringBuilder rValInt = new StringBuilder();
        while (quotient > 0) {
            remainder = quotient % base;
            quotient /= base;
            rValInt.append(parseDigit(remainder));
        }
        rValInt.reverse();
        StringBuilder rValDec = new StringBuilder();

        double decimal = Double.parseDouble(decNum);

        double rValTmp = toDecimal(intPart, "10");
        decimal = decimal - rValTmp;
        while (decimal > 0) {
            decimal *= base;
            rValDec.append(parseDigit((int) decimal));
            decimal = decimal - (int) decimal;
        }
        return rValInt.toString() + "." + rValDec.toString();
    }

    private static void conversionsFromDec() {
        System.out.println("14.0, 2=" + fromDec("14", "2"));
        System.out.println("45, 2=" + fromDec("45", "2"));
        System.out.println("222, 2=" + fromDec("222", "2"));
        System.out.println("3402, 8=" + fromDec("3402", "8"));
        System.out.println("467, 8=" + fromDec("467", "8"));
        System.out.println("1862, 8=" + fromDec("1862", "8"));
        System.out.println("667188, 16=" + fromDec("667188", "16"));
        System.out.println("242511, 16=" + fromDec("242511", "16"));
        System.out.println("766261, 16=" + fromDec("766261", "16"));
        System.out.println("-----------------------");
        System.out.println("22.375, 2=" + fromDec("22.375", "2"));
        System.out.println("19.625, 2=" + fromDec("19.625", "2"));
        System.out.println("27.875, 2=" + fromDec("27.875", "2"));
        System.out.println("436.625, 8=" + fromDec("436.625", "8"));
        System.out.println("499.3046875, 8=" + fromDec("499.3046875", "8"));
        System.out.println("232.75, 8=" + fromDec("232.75", "8"));
        System.out.println("667188.625, 16=" + fromDec("667188.625", "16"));
        System.out.println("73579.66640625, 16=" + fromDec("735796.6640625", "16"));
        System.out.println("766261.10546875, 16=" + fromDec("766261.10546875", "16"));
        System.out.println("667188.625, 2=" + fromDec("667188.625", "2"));
    }

    private static void conversionsToDec() {
        System.out.println("1110,2 = " + toDecimal("1110", "2"));
        System.out.println("101101,2 = " + toDecimal("101101", "2"));
        System.out.println("11011110,2 = " + toDecimal("11011110", "2"));
        System.out.println("6512, 8 = " + toDecimal("6512", "8"));
        System.out.println("723, 8 = " + toDecimal("723", "8"));
        System.out.println("3506, 8 = " + toDecimal("3506", "8"));
        System.out.println("A2E34,16 = " + toDecimal("A2E34", "16"));
        System.out.println("3B34F,16 = " + toDecimal("3B34F", "16"));
        System.out.println("BB135,16 = " + toDecimal("BB135", "16"));
        System.out.println("-----------------------------------------");
        System.out.println("10110.011,2 = " + toDecimal("10110.011", "2"));
        System.out.println("10011.101,2 = " + toDecimal("10011.101", "2"));
        System.out.println("11011.111,2 = " + toDecimal("11011.111", "2"));
        System.out.println("664.5, 8 = " + toDecimal("664.5", "8"));
        System.out.println("763.234, 8 = " + toDecimal("763.234", "8"));
        System.out.println("350.6, 8 = " + toDecimal("350.6", "8"));
        System.out.println("A2E34.A,16 = " + toDecimal("A2E34.A", "16"));
        System.out.println("B3A34.AA,16 = " + toDecimal("B3A34.AA", "16"));
        System.out.println("BB135.1B,16 = " + toDecimal("BB135.1B", "16"));
    }

    public static void main(String[] args) {
         System.out.println("10101.101 = " + toDecimal("10101.101", "2"));
         System.out.println("A2B.A = " + toDecimal("A2B.A", "16"));
         System.out.println("123 = " + fromDec("123", "2"));
          System.out.println("222.5=" + fromDec("222.5", "2"));
          System.out.println("332.2=" + fromDec("332.2", "2"));
          System.out.println("6718.25=" + fromDec("6718.25", "16"));
        //conversionsToDec();
        //conversionsFromDec();
        //System.out.println("1001001000, 2 = " + toDecimal("1001001000", "2"));

    }
}
