/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k7.v1.x;

public class X {

    public static int max(int[] tbl) { //Κώδικας 7.17
        int max = tbl[0];
        int idx = 0;
        for (int i = 1; i < tbl.length; i++) {
            if (tbl[i] > max) {
                idx = i;
                max = tbl[i];
            }
        }
        return idx;
    }

    static double[] triwnymo(double a, double b, double c) { // Κώδικας 7.18
        if (a == 0) {
            throw new RuntimeException();
        }
        double[] rVal = new double[3];
        double d = b * b - 4 * a * c;
        rVal[0] = d;
        if (d < 0) {
            rVal[1] = rVal[2] = Double.NaN;
            return rVal;
        }
        rVal[1] = (-b + Math.sqrt(d)) / (2 * a);
        rVal[2] = (-b - Math.sqrt(d)) / (2 * a);
        return rVal;
    }

    static void klisiTriwnymo() { // Κώδικας 7.19
        double[] solution = triwnymo(2, 5, -1);
        if (solution[0] < 0) {
            System.out.println("Η Εξίσωση δεν έχει λύση στο R");
        } else {
            System.out.println("χ1=" + solution[1] + " x2=" + solution[2]);
        }
    }

    static void klisiTriwnymo2() { // Κώδικας 7.20
        double[] solution = triwnymo(2, 5, -1);
        if (Double.isNaN(solution[1])) {
            System.out.println("Η Εξίσωση δεν έχει λύση στο R");
        } else {
            System.out.println("χ1=" + solution[1] + " x2=" + solution[2]);
        }
    }

    static double[] triwnymo(double[] syn) { // Κώδικας 7.21
        return triwnymo(syn[0], syn[1], syn[2]);
    }

    static long fibonacci(int fibIdx) { //Κώδικας 7.23
        if (fibIdx < 0) {
            throw new RuntimeException();
        } else if (fibIdx <= 1) {
            return fibIdx;
        }
        int n = 2;
        long current = 1, previous = 1, beforePrevious;
        while (++n <= fibIdx) {
            beforePrevious = previous;
            previous = current;
            current = beforePrevious + previous;
        }
        return current;
    }

    static String lektiko(int num) { //Κώδικας 7.24
        if (num < 0 || num > 999) {
            throw new RuntimeException();
        }
        if (num == 0) {
            return "μηδέν";
        }
        int ekatontades = num / 100;
        num -= ekatontades * 100;
        int dekades = num / 10;
        num -= dekades * 10;
        String hundreds = "", tens = "", units = "";
        switch (ekatontades) {
            case 0:
                break;
            case 1:
                hundreds = "εκατόν";
                break;
            case 2:
                hundreds = "διακόσια";
                break;
            case 3:
                hundreds = "τριακόσια";
                break;
            case 4:
                hundreds = "τετρακόσια";
                break;
            case 5:
                hundreds = "πεντακόσια";
                break;
            case 6:
                hundreds = "εξακόσια";
                break;
            case 7:
                hundreds = "επτακόσια";
                break;
            case 8:
                hundreds = "οκτακοσια";
                break;
            case 9:
                hundreds = "εννιακόσια";
                break;
        }
        switch (dekades) {
            case 0:
                break;
            case 1:
                tens = "δέκα";
                break;
            case 2:
                tens = "είκοσι";
                break;
            case 3:
                tens = "τριάντα";
                break;
            case 4:
                tens = "σαράντα";
                break;
            case 5:
                tens = "πενήντα";
                break;
            case 6:
                tens = "εξήντα";
                break;
            case 7:
                tens = "εβδομήντα";
                break;
            case 8:
                tens = "ογδόντα";
                break;
            case 9:
                tens = "ενενήντα";
                break;
        }
        switch (num) {
            case 0:
                break;
            case 1:
                if (tens.equals("δέκα")) {
                    tens = "έντεκα";
                } else {
                    units = "ένα";
                }
                break;
            case 2:
                if (tens.equals("δέκα")) {
                    tens = "δώδεκα";
                } else {
                    units = "δύο";
                }
                break;
            case 3:
                units = "τρία";
                break;
            case 4:
                units = "τέσσερα";
                break;
            case 5:
                units = "πέντε";
                break;
            case 6:
                units = "έξη";
                break;
            case 7:
                units = "επτά";
                break;
            case 8:
                units = "οκτώ";
                break;
            case 9:
                units = "εννέα";
                break;
        }
        String rVal = hundreds + (tens != "" ? " " : "") + tens + (units != "" ? " " : "") + units;
        //return rVal;
        return rVal.trim();
    }

    static int idxOfMinSum(int[][] t, int startIdx) { //Κώδικας 7.26
        int min = MyArrays.sum(t[startIdx]);
        int rVal = startIdx;
        for (int i = startIdx + 1; i < t.length; i++) {
            if (MyArrays.sum(t[i]) < min) {
                min = MyArrays.sum(t[i]);
                rVal = i;
            }
        }
        return rVal;
    }

    public static void sortSubArraysBySum(int[][] t) { //Κώδικας 7.27
        for (int i = 0; i < t.length; i++) {
            int mIdx = idxOfMinSum(t, i);
            if (mIdx != i) {
                int[] local = t[i];
                t[i] = t[mIdx];
                t[mIdx] = local;
            }
        }
    }

    public static void main(String[] args) {
        for (int i = 0; i < 500; i++) {
            System.out.println(i + " " + lektiko(i));
        }
        double[] ex1 = {2, 5, -1}, ex2 = {4, 4, -9};
        double[] solution1 = triwnymo(ex1);
        double[] solution2 = triwnymo(ex2);

    }
}
