/*
 * Κώδικας 8.5
 * 
 */
package gr.ihu.cs.lmous.OOJ.k8.v1;

import java.util.Random;

public class ADiceGame {

    public static double EPSILON = 0.00001;
    private static final Random gen = new Random();
    static final double[] fair = {1 / 6d, 1 / 6d, 1 / 6d, 1 / 6d, 1 / 6d, 1 / 6d};
    static final double[] lucky = {15d / 100, 18d / 100, 15d / 100, 18d / 100, 15d / 100, 19d / 100};
    static final double[] unlucky = {18d / 100, 15d / 100, 18d / 100, 15d / 100, 19d / 100, 15d / 100};
    private static final int JOHN = 0;
    private static final int JIM = 1;
    private static final int JACK = 2;

    public static boolean approximateEquals(double d1, double d2) {
        return Math.abs(d1 - d2) < EPSILON;
    }

    public static double sum(double[] array) {
        double sum = 0;
        for (double d : array) {
            sum += d;
        }
        return sum;
    }

    public static int roll(double[] distribution) {
        if (distribution.length != 6 || !approximateEquals(sum(distribution), 1d)) {
            throw new RuntimeException();
        }
        double value = gen.nextDouble();
        double sum = 0;
        int rslt = 1;
        for (double percentage : distribution) {
            sum += percentage;
            if (value <= sum) {
                return rslt;
            }
            rslt++;
        }
        return 0;
    }

    public static int max(int[] array) {
        int idx = 0;
        int max = array[0];
        for (int i = 1; i < array.length; i++) {
            if (array[i] > max) {
                max = array[i];
                idx = i;
            }
        }
        return idx;
    }

    public static int cntOccurances(int[] array, int value) {
        int cnt = 0;
        for (int i = 0; i < array.length; i++) {
            if (value == array[i]) {
                cnt++;
            }
        }
        return cnt;
    }

    public static boolean withdraw(int[] score) {
        return cntOccurances(score, score[max(score)]) > 1;
    }

    private static int[] aLot(int noOfRolls) {
        int[] score = new int[3];
        for (int i = 0; i < noOfRolls; i++) {
            int rslt = roll(fair);
            if (rslt % 2 == 0) {
                score[JOHN]++;
            }

            rslt = roll(lucky);
            if (rslt % 2 == 0) {
                score[JIM]++;
            }

            rslt = roll(unlucky);
            if (rslt % 2 == 0) {
                score[JACK]++;
            }
        }
        return score;
    }

    public static int game() {
        final int NOOFROLLS = 10;
        int[] score;

        do {
            score = aLot(NOOFROLLS);
        } while (withdraw(score));
        return max(score);
    }

    private static String winnerName(int winnerId) {

        switch (winnerId) {
            default:
                throw new RuntimeException();
            case JOHN:
                return "John";
            case JIM:
                return "Jim";
            case JACK:
                return "Jack";
        }
    }

    public static void main(String[] args) {
        int winnerId = game();
        System.out.println("winner is " + winnerName(winnerId));
    }
}
