/*
 * Κώδικας 8.11
 * 
 */
package gr.ihu.cs.lmous.OOJ.k8.x;

public class CharArrayLib {

    static char[] create(String s) {
        return s.toCharArray();
    }

    static int compare(char[] s1, char[] s2) {
        int idx = 0;
        while (idx < s1.length && idx < s2.length) {
            if (s1[idx] > s2[idx]) {
                return 1;
            }
            if (s1[idx] < s2[idx]) {
                return -1;
            }
            idx++;
        }
        return s1.length-s2.length;
    }

    static int compareIgnoreCase(char[] s1, char[] s2) {
        int idx = 0;
        while (idx < s1.length && idx < s2.length) {
            char u1 = Character.toUpperCase(s1[idx]),
                    u2 = Character.toUpperCase(s2[idx]);
            if (u1 > u2) {
                return 1;
            }
            if (u1 < u2) {
                return -1;
            }
            idx++;
        }
        
        return s1.length - s2.length;
    }

    static char[] concat(char[] s1, char[] s2) {
        char[] rVal = new char[s1.length + s2.length];
        System.arraycopy(s1, 0, rVal, 0, s1.length);
        System.arraycopy(s2, 0, rVal, s1.length, s2.length);
        return rVal;
    }

    public static boolean equals(char[] tA, char[] tB) {
        if (tA.length != tB.length) {
            return false;
        }
        for (int i = 0; i < tA.length; i++) {
            if (tA[i] != tB[i]) {
                return false;
            }
        }
        return true;
    }

    static char[] subString(char[] s, int from, int to) {
        char[] rVal = new char[to - from];
        int idx = 0;
        for (int i = from; i < to; i++) {
            rVal[idx++] = s[i];
        }
        return rVal;
    }

    static int contains(char[] s, char... cS) {
        if (cS.length > s.length) {
            return -1;
        }

        for (int i = 0; i < s.length - cS.length; i++) {
            char[] sub = subString(s, i, cS.length + i);
            if (equals(sub, cS)) {
                return i;
            }
        }
        return -1;
    }

    public static void main(String[] args) {
        char[] s1 = create("Erik"), s2 = create("son");
        char[] con = concat(s1, s2);
        int idx = contains(con, s1);
        System.out.println(idx);
        idx = contains(con, s2);
        System.out.println(idx);
        char[] s4 =create("EriksoN");
        System.out.println(compareIgnoreCase(con,s4));
    }
}
