/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package gr.ihu.cs.lmous.OOJ.k8.x;

import java.util.Arrays;
import java.util.Random;

public class DeckGame {

    static final int JOHN = 0;
    static final int JIM = 1;
    static final int MARY = 2;
    static final int ANN = 3;

    static final String[] players = {"John", "Jim", "Mary", "Ann"};
    static int[][][] onHand = new int[players.length][4][2];
    static int[][][] earned = new int[players.length][52][2];

    static int top = 0;

    static void init(int[][] cards) {
        for (int i = 0; i < cards.length; i++) {
            Arrays.fill(cards[i], 0);
        }
    }

    static void init(int[][][] cards) {
        for (int i = 0; i < cards.length; i++) {
            for (int j = 0; j < cards[i].length; j++) {
                Arrays.fill(cards[i][j], 0);
            }
        }
    }

    static int[] createCard(int value, int color) {
        int[] card = new int[2];
        card[0] = value;
        card[1] = color;
        return card;
    }

    static int[][] createDeck() {
        int[][] deck = new int[52][2];
        int idx = 0;
        for (int i = 1; i <= 13; i++) {
            for (int j = 1; j <= 4; j++) {
                deck[idx++] = createCard(i, j);
            }
        }
        return deck;
    }

    static String toString(int[] card) {
        String vName = "";
        switch (card[0]) {
            case 1:
                vName = "Assos";
                break;
            case 2:
                vName = "Dyo";
                break;
            case 3:
                vName = "Tria";
                break;
            case 4:
                vName = "Tessera";
                break;
            case 5:
                vName = "Pente";
                break;
            case 6:
                vName = "Exi";
                break;
            case 7:
                vName = "Epta";
                break;
            case 8:
                vName = "Oktw";
                break;
            case 9:
                vName = "Ennea";
                break;
            case 10:
                vName = "Deka";
                break;
            case 11:
                vName = "Bales";
                break;
            case 12:
                vName = "Ntama";
                break;
            case 13:
                vName = "Rigas";
                break;
        }
        String cName = "";
        switch (card[1]) {
            case 1:
                cName = "Koupa";
                break;
            case 2:
                cName = "Karw";
                break;
            case 3:
                cName = "Mpastouni";
                break;
            case 4:
                cName = "Spathi";
                break;
        }
        return vName + " " + cName;
    }

    static String toString(int[][] cards) {
        String rVal = "";
        for (int i = 0; i < cards.length; i++) {
            rVal += toString(cards[i]) + " ";
        }
        return rVal;
    }

    public static void shuffle(int[][] t) {
        Random r = new Random();

        for (int i = 0; i < t.length; i++) {
            int rIdx = r.nextInt(t.length);
            int[] tmp = t[i];
            t[i] = t[rIdx];
            t[rIdx] = tmp;
        }
    }

    public static void prtDeck(int[][] deck) {
        for (int i = 0; i < deck.length; i++) {
            System.out.println(toString(deck[i]));
        }
    }

    public static int[][] pop(int[][] deck, int[][] toHand) {
        for (int i = 0; i < 4; i++) {
            toHand[i] = deck[i];
        }
        return Arrays.copyOfRange(deck, 4, deck.length);
    }

    public static int[] open(int[][] onHand, int turn) {
        int[] card = onHand[turn];
        return card;
    }

    public static boolean equalValue(int[] c1, int[] c2) {
        return c1[0] == c2[0];
    }

    public static boolean winnerCard(int[] card) {
        return card[0] == 11;
    }

    public static void move(int[] card, int[][] stack) {
        System.out.println("move " + toString(card) + " to stack");
        stack[++top] = card;
    }

    static int[] copy(int[] card) {
        int[] copy = new int[card.length];
        for (int i = 0; i < card.length; i++) {
            copy[i] = card[i];
        }
        return copy;
    }

    public static void move(int[][] stack, int[][] earned) {
        System.out.println("move stack " + toString(stack) + " to earned");
        int entry = noOfCards(earned);
        for (int i = 0; i <= top; i++) {
            earned[entry++] = copy(stack[i]);
        }
        System.out.println("earned=" + toString(earned));
        init(stack);
        top = -1;
    }

    static int noOfCards(int[][] earned) {
        for (int i = 0; i < earned.length; i++) {
            if (earned[i][0] == 0) {
                return i;
            }
        }
        return -1;
    }

    static int maxCards(int[][][] earned) {
        int max = 0, rVal = -1;
        for (int i = 0; i < earned.length; i++) {
            int cards = noOfCards(earned[i]);
            if (cards > max) {
                max = cards;
                rVal = i;
            }
        }
        return rVal;

    }

    static int cardsPontoi(int[][] earned) {
        int rVal=0;
        for (int i=0; i<earned.length; i++)
            if (earned[i][0]!=0)
                rVal+=earned[i][0];
        return rVal;
    }
    
    public static void main(String[] args) {
        int[][] deck = createDeck();

        //init(onHand);
        //init(earned);
        shuffle(deck);
        int[][] stack = new int[52][2];
        deck = pop(deck, stack);
        top = 3;

        while (deck.length > 0) {
            deck = pop(deck, onHand[JOHN]);
            deck = pop(deck, onHand[JIM]);
            deck = pop(deck, onHand[MARY]);
            deck = pop(deck, onHand[ANN]);
            System.out.println("Moirasma");
            System.out.println(" stack " + toString(stack));
            System.out.println(" John " + toString(onHand[JOHN]));
            System.out.println(" Jim " + toString(onHand[JIM]));
            System.out.println(" Mary " + toString(onHand[MARY]));
            System.out.println(" Ann " + toString(onHand[ANN]));
            for (int i = 0; i < 4; i++) {
                for (int j = 0; j < players.length; j++) {
                    int[] card = open(onHand[j], i);
                    System.out.println("playing " + players[j] + " " + toString(card));
                    if ((top > -1) && (equalValue(card, stack[top]) || winnerCard(card))) {
                        move(card, stack);
                        move(stack, earned[j]);
                    } else {
                        move(card, stack);
                    }
                }

            }
        } //while

        int playerWithMoreCards = maxCards(earned);
        move(stack, earned[playerWithMoreCards]);

        for (int i = 0; i < earned.length; i++) {
            int k = noOfCards(earned[i]);
            System.out.println(players[i] + " " + k);
            for (int j = 0; j < earned[i].length; j++) {
                if (earned[i][j][0] != 0) {
                    System.out.print(toString(earned[i][j]) + " ");
                }
            }
            System.out.println("");
        }

        // Stats
        System.out.println("player "+players[JOHN]+" pontoi = "+cardsPontoi(earned[JOHN]));
        System.out.println("player "+players[JIM]+" pontoi = "+cardsPontoi(earned[JIM]));
        System.out.println("player "+players[MARY]+" pontoi = "+cardsPontoi(earned[MARY]));
        System.out.println("player "+players[ANN]+" pontoi = "+cardsPontoi(earned[ANN]));
        System.out.println("total deck pontoi = "+cardsPontoi(createDeck()));
    }
}
