package gr.ihu.cs.lmous.OOJ.k9.x;

/**
 *
 * @author Lefteris Moussiades
 */
public class RecursiveSortAndSearch {

    private static void swap(int[] array, int idx1, int idx2) {
        int i = array[idx1];
        array[idx1] = array[idx2];
        array[idx2] = i;
    }

    private static int idxOfMin(int[] array, int startIdx) {
        int min = array[startIdx];
        int rVal = startIdx;
        for (int i = startIdx + 1; i < array.length; i++) {
            if (array[i] < min) {
                min = array[i];
                rVal = i;
            }
        }
        return rVal;
    }

    private static void sort(int[] array, int startIdx) {
        int posOfMin = idxOfMin(array, startIdx);
        if (posOfMin != startIdx) {
            swap(array, posOfMin, startIdx);
        }
        startIdx++;
        if (startIdx < array.length - 1) {
            sort(array, startIdx);
        }
    }

    public static void sort(int[] array) {
        sort(array, 0);
    }

    private static int binarySearch(int[] tbl, int schElement, int from, int to) {
        if (from <= to) {
            int mid = from + (to - from) / 2;
            if (tbl[mid] == schElement) {
                return mid;
            }
            if (schElement < tbl[mid]) {
                return binarySearch(tbl, schElement, from, mid - 1);
            }
            return binarySearch(tbl, schElement, mid + 1, to);
        }
        return -1;
    }
    


    public static int binarySearch(int[] tbl, int schElement) {
        return binarySearch(tbl, schElement, 0, tbl.length - 1);
    }

    public static void main(String[] args) {
       
        int[] tbl = {2, 1, 8, 6, 5, 4};
        sort(tbl);
        for (int e : tbl) {
            System.out.print(e+" ");
        }
        System.out.println();
        System.out.println(binarySearch(tbl, 1));
        System.out.println(binarySearch(tbl, 4));
        System.out.println(binarySearch(tbl, 2));
        System.out.println(binarySearch(tbl, 8));

    }

}
