/*
 * Here comes the text of your license
 * Each line should be prefixed with  * 
 */
package tmp;

import gr.ihu.cs.lmous.OOJ.k12.v1.x.Person;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;

public class MyHashMap { // Κώδικας 12.20

    private static final int SIZE = 3;
    private final ArrayList<Person>[] store = new ArrayList[SIZE];

    public void put(Person person) {
        if (person == null) {
            return;
        }
        String id = person.getId();
        int hashCode = id.hashCode();
        int idx = hashCode % store.length;
        if (store[idx] == null) {
            store[idx] = new ArrayList<>();
        }
        if (!store[idx].contains(person)) {
            store[idx].add(person);
        }
    }

    Person get(String id) {
        int hashCode = id.hashCode();
        int idx = hashCode % store.length;
        if (store[idx] == null) {
            return null;
        }
        int idLocation = -1;
        for (int i = 0; i < store[idx].size(); i++) {
            if (store[idx].get(i).getId().equals(id)) {
                idLocation = i;
                break;
            }
        }
        if (idLocation == -1) {
            return null;
        }
        return store[idx].get(idLocation);
    }

    Person remove(String id) {
        int hashCode = id.hashCode();
        int idx = hashCode % store.length;
        if (store[idx] == null) {
            return null;
        }
        int idLocation = -1;
        for (int i = 0; i < store[idx].size(); i++) {
            if (store[idx].get(i).getId().equals(id)) {
                idLocation = i;
                break;
            }
        }
        if (idLocation == -1) {
            return null;
        }
        return store[idx].remove(idLocation);
    }

    @Override
    public String toString() {
        StringBuilder rVal = new StringBuilder("");
        for (ArrayList<Person> cStore : store) {
            if (cStore != null) {
                for (int j = 0; j < cStore.size(); j++) {
                    rVal.append(cStore.get(j)).append("\n");
                }
            }
        }
        return rVal.toString();
    }

    public static void main(String[] args) {
        Person p1 = new Person("A1", "Jim", "Black", LocalDate.of(1961, Month.MARCH, 1));
        Person p2 = new Person("A2", "Jack", "Blue", LocalDate.of(1967, Month.MARCH, 1));
        Person p3 = new Person("A3", "Jim", "Green", LocalDate.of(1971, Month.MARCH, 1));
        Person p4 = new Person("A4", "Mary", "White", LocalDate.of(1961, Month.MARCH, 1));
        Person p5 = new Person("A5", "Ann", "Red", LocalDate.of(1967, Month.MARCH, 1));
        Person p6 = new Person("A6", "Kelly", "Pink", LocalDate.of(1971, Month.MARCH, 1));
        MyHashMap map = new MyHashMap();
        map.put(p1);
        map.put(p2);
        map.put(p3);
        map.put(p4);
        map.put(p5);
        map.put(p6);

        System.out.println(map.get(p1.getId()));
        System.out.println(map.get(p2.getId()));
        System.out.println(map.get(p3.getId()));
        System.out.println(map.get(p4.getId()));
        System.out.println(map.get(p5.getId()));
        System.out.println(map.get(p6.getId()));
        System.out.println("after fName replacement--------");
        p1.setfName("Jameson");
        //map.put(p1);
        System.out.println(map.get(p1.getId()));
        System.out.println(map.remove(p1.getId()));
        System.out.println("after remove One--------");
        System.out.println(map.get(p1.getId()));
        System.out.println("print map------------------");
        System.out.println(map);
    }
}
