/*
 * 
 * Κώδικας 8.9
 * 
 */
package gr.ihu.cs.lmous.OOJ.k8.v1;

import java.util.Random;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Lefteris Moussiades <lmous@cs.ihu.gr>
 */
public class ADiceGameTest {

    /**
     * Test of approximateEquals method, of class ADiceGame.
     */
    @Test
    public void testApproximateEquals() {
        System.out.println("approximateEquals");
        double d1 = 0.0;
        double d2 = ADiceGame.EPSILON;
        boolean result = ADiceGame.approximateEquals(d1, d2);
        assertEquals(false, result);
        d2 = ADiceGame.EPSILON / 2;
        assertEquals(true, ADiceGame.approximateEquals(d1, d2));
    }

    /**
     * Test of sum method, of class ADiceGame.
     */
    @Test
    public void testSum() {
        System.out.println("sum");
        double[] array = ADiceGame.fair;
        double result = ADiceGame.sum(array);
        assertEquals(1d, result, ADiceGame.EPSILON);
        array = ADiceGame.lucky;
        result = ADiceGame.sum(array);
        assertEquals(1d, result, ADiceGame.EPSILON);
        array = ADiceGame.unlucky;
        result = ADiceGame.sum(array);
        assertEquals(1d, result, ADiceGame.EPSILON);
    }

    /**
     * Test of roll method, of class ADiceGame.
     */
    @Test
    public void testRoll() {
        System.out.println("roll");
        double[] distribution;
        int sumFair = 0, sumLucky = 0, sumUnlucky = 0, rslt;
        for (int i = 0; i < 10000; i++) {
            rslt = ADiceGame.roll(ADiceGame.fair);
            if (rslt < 1 || rslt > 6) {
                fail("roll result " + rslt);
            }
            sumFair += rslt % 2 == 0 ? 1 : 0;
            rslt = ADiceGame.roll(ADiceGame.lucky);
            if (rslt < 1 || rslt > 6) {
                fail("roll result " + rslt);
            }
            sumLucky += rslt % 2 == 0 ? 1 : 0;
            rslt = ADiceGame.roll(ADiceGame.unlucky);
            if (rslt < 1 || rslt > 6) {
                fail("roll result " + rslt);
            }
            sumUnlucky += rslt % 2 == 0 ? 1 : 0;
        }
        System.out.println(sumLucky/10000d+" "+sumFair/10000d+" "+sumUnlucky/10000d);
        assertTrue(sumLucky > sumFair && sumFair > sumUnlucky);
    }

    /**
     * Test of max method, of class ADiceGame.
     */
    public static void shuffle(int[] t) {
        Random r = new Random();

        for (int i = 0; i < t.length; i++) {
            int rIdx = r.nextInt(t.length);
            int tmp = t[i];
            t[i] = t[rIdx];
            t[rIdx] = tmp;
        }
    }

    private int[] constructArray(int initialValue) {
        int[] rVal = new int[10];
        for (int i = 0; i < 10; i++) {
            rVal[i] = initialValue + i;
        }
        shuffle(rVal);
        return rVal;
    }

    @Test
    public void testMax() {
        System.out.println("max");
        int arrayNo = 0, initialValue = 1;
        int[] array;
        while (arrayNo < 1000) {
            array = constructArray(initialValue);
            assertEquals(initialValue + 9, array[ADiceGame.max(array)]);
            initialValue += 10;
            arrayNo++;
        }
    }

    /**
     * Test of cntOccurances method, of class ADiceGame.
     */
    @Test
    public void testCntOccurances() {
        System.out.println("cntOccurances");
        int[] array = {1, 2, 2, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6};
        assertEquals(1, ADiceGame.cntOccurances(array, 1));
        assertEquals(2, ADiceGame.cntOccurances(array, 2));
        assertEquals(3, ADiceGame.cntOccurances(array, 3));
        assertEquals(4, ADiceGame.cntOccurances(array, 4));
        assertEquals(5, ADiceGame.cntOccurances(array, 5));
        assertEquals(6, ADiceGame.cntOccurances(array, 6));
    }

    /**
     * Test of withdraw method, of class ADiceGame.
     */
    @Test
    public void testWithdraw() {
        System.out.println("withdraw");
        int[] score = {1100,5,1100};
        ADiceGame.withdraw(score);
        assertTrue(ADiceGame.withdraw(score));
        score[2] = 6;
        assertFalse(ADiceGame.withdraw(score));
    }

   //https://www.nathanbak.com/?p=388
}

